/**
* JSAX.AE - ActiveElements
* 
* for testing:
require( "AE"); window.test = document.createElement( "div"); test.className="activeElement"; test.src="../saxML/?call=time:Ymd - H:i:s"; test.timeout=1; document.body.appendChild( test); document.body.appendChild( document.createElement( "br")); document.body.appendChild( document.createElement( "br")); JSAX.AE.start(); test

*
* Copyright (C) 2006 Florian Sax <flosax(at)users.sourceforge.net>
* JSAX.AE is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*
* You must run this example before the following examples work
* @example include( "./objects/AE.js");
var test = document.createElement( "div");
test.id="testElement";
test.className="myFrames activeElement";  // set the className, so the element gets loaded
test.style.position = "fixed";
test.style.right = "0px";
test.style.bottom = "0px";
test.style.height = "150px";
test.style.width = "300px";
test.style.background = "#EEEECC";
test.style.innerHTML = "testElement";
document.body.appendChild( test);
test.src="objects/AE.js";            // the src attribute sets the location that will be loaded
null
*/

if( !window.JSAX){
	alert( "JSAX.AE - ActiveElements is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}

require( "DOM", "proto/Element");
JSAX.AE = {
	Version: 20060102,
	Doc: 20060212,

/**
* JSAX.AE.start - Starts the active elements
* 
* @parent JSAX.AE
*
* @example JSAX.AE.start()
*/
	start: function(){
		JSAX.AE.loadClass( "activeElement");
	},

/**
* JSAX.AE.loadClass - Starts the active elements
* 
* @parent JSAX.AE
*
* @param String className - The class of the elements which you want to activate
*
* @example byId( "testElement").src="objects/JSAX.js";
JSAX.AE.loadClass( "myFrames"); 1
*/
	loadClass: function( className){
		var elems = document.getElementsByClassName( className);
		for( var i=0; i < elems.length; i++){
			JSAX.AE.loadElement( elems[i]);
		}
	},

	counter: 1,
/**
* JSAX.AE.loadElement - Reloads a element periodically
* 
* @parent JSAX.AE
*
* @param Object elem - The element which you wan to load
*
* @example byId( "testElement").src="readme.txt";
byId( "testElement").timeout=3; // set a timeout so the element reloads speriodically after 3secounds
JSAX.AE.loadElement( byId( "testElement")); 1
* @example byId( "testElement").src="gpl.txt";
byId( "testElement").timeout=0; // set the timeout to zero to prevent the element from reloading
JSAX.AE.loadElement( byId( "testElement")); 1
*/
	loadElement: function( elem){
		elem.innerHTML = read( elem.src);
		if( elem.timeout){
			if( !elem.id){
				elem.id = "activeElement"+JSAX.AE.counter++;
			}
			setTimeout( "JSAX.AE.loadElement( byId( '"+elem.id+"'));", elem.timeout *1000);
		}
		if( typeof( elem.onload) == "function"){
			elem.onload();
		}
	}
};

