/**
* Cascade.js
* this library separates an verifies cascades as CSS or CJSED.
* Cascade is writteb by Florian Sax under the GPL license <http://www.gnu.org/copyleft/gpl.html>
*/

if( !window.JSAX){
	alert( "Cascade is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}

require( "proto/String");

JSAX.Cascade = {
	Version: 20060126,
	
	splitRules: function( cascadeString){
		var cascadeString = cascadeString.removeScriptComments();
		if( !JSAX.Cascade.lint( cascadeString)){
			return false;
		}

		var rules = new Array();
		while( cascadeString.pos( "}") != -1){
			var closePos = cascadeString.pos( "}") +1;
			var rule = cascadeString.substring( 0, closePos);
			while( rule.indexCount( "{") > rule.indexCount( "}")){ // find innerCascades ( body { if{} })
				closePos += cascadeString.substring( closePos).pos( "}") +1;
				rule = cascadeString.substring( 0, closePos);
			}
			rules.push( JSAX.Cascade.createRule( rule));
			cascadeString = cascadeString.substring( closePos);
		}
		if( cascadeString.pos( "{") != -1
		 || cascadeString.pos( "}") != -1){
			rules.push( JSAX.Cascade.createRule( cascadeString));
		}
		return rules;
	},
	lint: function( cascadeString){
		if( cascadeString.pos( "{") == -1){
			return false;
		}
		if( cascadeString.indexCount( "{") != cascadeString.indexCount( "}")){
			return false;
		}else{
			return true;
		}
	},
	getRuleTargetElements: function( rule){
		return "unimplemented";
	},
	getSelectorStatementAttributes: function( selectorStatement){
		attribs = new Array();
		var className = /(\.[^#:])/.match( selectorStatement)[0];
		alert( className);
		return "unimplemented";
	},
	createRule: function( rule){
		var ruleKeys = rule.substring( 0, rule.pos( "{")).trim();
		var ruleValue = rule.substring( rule.pos( "{") +1).trim().chopEnd( "}").trim();
		var args = ruleValue.trimSplit( ";");
		for( var i=0; i < args.length; i++){
			args[i] = args[i].trimSplit( ":");
		}
		var sels = ruleKeys.trimSplit( ",");
		for( var i=0; i < sels.length; i++){
			sels[i] = sels[i].trimSplit( " ");
		}
		
		rule = {
			text: ruleKeys+" { "+ruleValue+" }",
			selectorText: ruleKeys,
			argumentText: ruleValue,
			selectors: sels,
			arguments: args
		}
		return rule;
	}
};