


if( !window.JSAX){
	alert( "JSAX.Color is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}
require( "proto/String", "code");









/**
* JSAX.Color
* Color handling and transformation library
* 
* written by Florian Sax 20060204
*
* Copyright (C) 2006 Florian Sax <flosax(at)users.sourceforge.net>
* JSAX.Color is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
* @Version 20060204
*
* Run this example to get sure JSAX.Color library is loaded
* @example require( "Color"); JSAX.Color.solv( "dodgerblue")
*/
JSAX.Color = {
	Version: 20060222,

/**
* A list of all the known colors
*
* @example require( "Color"); JSAX.Color.names
*/
	names: {
		black:			[  0,   0,   0],
		navy:			[  0,   0, 128],
		darkblue:		[  0,   0, 139],
		mediumblue:		[  0,   0, 205],
		blue:			[  0,   0, 255],
		darkgreen:		[  0, 100,   0],
		green:			[  0, 128,   0],
		teal:			[  0, 128, 128],
		darkcyan:		[  0, 139, 139],
		deepskyblue:		[  0, 191, 255],
		darkturquoise:		[  0, 206, 209],
		mediumspringgreen:	[  0, 250, 154],
		lime:			[  0, 255,   0],
		springgreen:		[  0, 255, 127],
		cyan:			[  0, 255, 255],
		aqua:			[  0, 255, 255],
		midnightblue:		[ 25,  25, 112],
		dodgerblue:		[ 30, 144, 255],
		lightseagreen:		[ 32, 178, 170],
		forestgreen:		[ 34, 139,  34],
		seagreen:		[ 46, 139,  87],
		darkslategray:		[ 47,  79,  79],
		limegreen:		[ 50, 205,  50],
		mediumseagreen:		[ 60, 179, 113],
		turquoise:		[ 64, 224, 208],
		royalblue:		[ 65, 105, 225],
		steelblue:		[ 70, 130, 180],
		darkslateblue:		[ 72,  61, 139],
		mediumturquoise:	[ 72, 209, 204],
		indigo:			[ 75,   0, 130],
		darkolivegreen:		[ 85, 107, 47],
		cadetblue:		[ 95, 158, 160],
		cornflowerblue:		[100, 149, 237],
		mediumaquamarine:	[102, 205, 170],
		dimgray:		[105, 105, 105],
		slateblue:		[106,  90, 205],
		olivedrab:		[107, 142,  35],
		slategray:		[112, 128, 144],
		lightslategray:		[119, 136, 153],
		mediumslateblue:	[123, 104, 238],
		lawngreen:		[124, 252,   0],
		gray:			[127, 127, 127],
		chartreuse:		[127, 255,   0],
		aquamarine:		[127, 255, 212],
		maroon:			[128,   0,   0],
		purple:			[128,   0, 128],
		olive:			[128, 128,   0],
		skyblue:		[135, 206, 235],
		lightskyblue:		[135, 206, 250],
		blueviolet:		[138,  43, 226],
		darkred:		[139,   0,   0],
		darkmagenta:		[139,   0, 139],
		saddlebrown:		[139,  69,  19],
		darkseagreen:		[143, 188, 143],
		lightgreen:		[144, 238, 144],
		mediumpurple:		[147, 112, 219],
		darkviolet:		[148,   0, 211],
		palegreen:		[152, 251, 152],
		darkorchid:		[153,  50, 204],
		sienna:			[160,  82,  45],
		brown:			[165,  42,  42],
		darkgray:		[169, 169, 169],
		lightblue:		[173, 216, 230],
		greenyellow:		[173, 255,  47],
		paleturquoise:		[175, 238, 238],
		lightsteelblue:		[176, 196, 222],
		powderblue:		[176, 224, 230],
		firebrick:		[178,  34,  34],
		darkgoldenrod:		[184, 134,  11],
		mediumorchid:		[186,  85, 211],
		rosybrown:		[188, 143, 143],
		darkkhaki:		[189, 183, 107],
		silver:			[192, 192, 192],
		mediumvioletred:	[199,  21, 133],
		indianred:		[205,  92,  92],
		peru:			[205, 133,  63],
		chocolate:		[210, 105,  30],
		tan:			[210, 180, 140],
		lightgrey:		[211, 211, 211],
		thistle:		[216, 191, 216],
		orchid:			[218, 112, 214],
		goldenrod:		[218, 165,  32],
		palevioletred:		[219, 112, 147],
		crimson:		[220,  20,  60],
		gainsboro:		[220, 220, 220],
		plum:			[221, 160, 221],
		burlywood:		[222, 184, 135],
		lightcyan:		[224, 255, 255],
		lavender:		[230, 230, 250],
		darksalmon:		[233, 150, 122],
		violet:			[238, 130, 238],
		palegoldenrod:		[238, 232, 170],
		lightcoral:		[240, 128, 128],
		khaki:			[240, 230, 140],
		aliceblue:		[240, 248, 255],
		honeydew:		[240, 255, 240],
		azure:			[240, 255, 255],
		sandybrown:		[244, 164,  96],
		wheat:			[245, 222, 179],
		beige:			[245, 245, 220],
		whitesmoke:		[245, 245, 245],
		mintcream:		[245, 255, 250],
		ghostwhite:		[248, 248, 255],
		salmon:			[250, 128, 114],
		antiquewhite:		[250, 235, 215],
		linen:			[250, 240, 230],
		lightgoldenrodyellow:	[250, 250, 210],
		tomato:			[253,  99,  71],
		oldlace:		[253, 245, 230],
		red:			[255,   0,   0],
		magenta:		[255,   0, 255],
		fuchsia:		[255,   0, 255],
		deeppink:		[255,  20, 147],
		orangered:		[255,  69,   0],
		hotpink:		[255, 105, 180],
		coral:			[255, 127,  80],
		darkorange:		[255, 140,   0],
		lightsalmon:		[255, 160, 122],
		orange:			[255, 165,   0],
		lightpink:		[255, 182, 193],
		pink:			[255, 192, 203],
		gold:			[255, 215,   0],
		peachpuff:		[255, 218, 185],
		navajowhite:		[255, 222, 173],
		moccasin:		[255, 228, 181],
		bisque:			[255, 228, 196],
		mistyrose:		[255, 228, 225],
		blanchedalmond:		[255, 235, 205],
		papayawhip:		[255, 239, 213],
		ivory:			[255, 240, 240],
		lavenderblush:		[255, 240, 245],
		seashell:		[255, 245, 238],
		cornsilk:		[255, 248, 220],
		lemonchiffon:		[255, 250, 205],
		floralwhite:		[255, 250, 240],
		snow:			[255, 250, 250],
		yellow:			[255, 255,   0],
		lightyellow:		[255, 255, 224],
		white:			[255, 255, 255],
		yellowgreen:		[154, 205,  50]
	},



/**
* NOTE under construction
*/
	rgb2hsl: function( RGBorR, G, B, dH, dS){
		if( typeof( arguments[0]) == "object"){
			var rgb = arguments[0];
		}else{
			var rgb = arguments;
		}

		var r = rgb[0];
		var g = rgb[1];
		var b = rgb[2];

		var ma = Math.max( r, g, b);
		var mi = Math.min( r, g, b);

//		var s = parseInt( ( r +g +b) /3);
		var h = 0;
		var s = 0;
		var l = 0;
		if( dH)var h = dH;
		if( dS)var h = dS;

		if( ma == 0){
			return [0, 255, 0];
		}


		var h = Math.round( ( g -b) / ( ma -mi));

		if( g < b){
		h += 360;
		}
		if( g == ma){
			h = Math.round( ( b -r) / ( ma -mi)) +120;
		}
		if( b == ma){
			h = Math.round( ( r -g) / ( ma -mi)) +240;
		}
		if( isNaN( h)){
			h = 0;
		}

		s = Math.round( ( ( ma -mi) /ma) *255);
		if( isNaN( s)){
			s = 0;
		}

		l = parseInt( ( r +g +b) /3);

		return [h, s, l];
	},

/**
* NOTE under construction
*/
	hsl2rgb: function( HSLorH, S, L, inverse){
		if( typeof( arguments[0]) == "object"){
			var hsl = arguments[0];
			var inverse = arguments[1];
		}else{
			var hsl = arguments;
		}

		var hue = hsl[0];
		var saturation = hsl[1] /255;
		var lightness = hsl[2] /255;

		var red, green, blue;
		if( inverse == 1){
			//hue = rotateColor(hue,180);
			
			if( ( lightness -( saturation / 2.0)) < 0.40){
				lightness = 1.0;
			}else{
				lightness = 0.0;
			}
			saturation = 0.2;
		}
	
		var base_line = ( (255.0 *lightness) * (1.0 -saturation) );
		var top_val = (255.0 *lightness);

		var differential = top_val -base_line;

		if( ( hue > 300) || ( hue < 60)){
			// red is the dominant colour.
			red = top_val;
			if (hue > 300){
				// towards blue
				blue = ( ( ( ( 360.0 -hue) /60.0) *differential) +base_line);
				green = base_line;
			}else{
				// towards green
				green = ( ( ( hue/60.0) *differential) +base_line);
				blue = base_line;
			}
		}else if( ( hue >=60) && ( hue <= 180)){
			// green is the dominant colour
			green = top_val;
			if( hue < 120){
				// toward red
				red = ( ( ( ( 120.0 -hue) /60.0) *differential) +base_line);
				blue = base_line;
			}else{
				// toward blue
				blue = ( ( ( ( hue -120.0) /60.0) *differential) +base_line);
				red = base_line;
			}
		}else{
			// blue is the dominant colour
			blue = top_val;
			if( hue < 240){
				// toward green
				green = ( ( ( ( 240.0 - hue) /60.0) *differential) +base_line);
				red = base_line;
			}else{
				// toward red
				red = ( ( ( ( hue  - 240.0) /60.0) *differential) +base_line);
				green = base_line;
			}
		}
		return [red, green, blue];
	},

	rgb2hsv: function( RGBorR, G, B, dH, dS){
		if( typeof( arguments[0]) == "object"){
			var rgb = arguments[0];
		}else{
			var rgb = arguments;
		}

		var r = rgb[0];
		var g = rgb[1];
		var b = rgb[2];

		var ma = Math.max( r, g, b);
		var mi = Math.min( r, g, b);

		if( !dH)var dH = 0;
		if( !dS)var dS = 0;

		var h = dH;
		var s = dS;
		var v = ma;

		var div = ma -mi;
		if( div){
			var dlR = ( ( ( ma -r ) /6) +( div /2)) /div;
			var dlG = ( ( ( ma -g ) /6) +( div /2)) /div;
			var dlB = ( ( ( ma -b ) /6) +( div /2)) /div;
			
			if     ( r == ma)h = dlB -dlG;
			else if( g == ma)h = ( 1 /3) +dlR -dlB;
			else if( b == ma)h = ( 2 /3) +dlG -dlR;

			if( h < 0 )h += 1;
			if( h > 1 )h -= 1;

			var s = Math.round( ( div /ma) *2550) /10;
			h = Math.round( h *3600) /10;

			if( isNaN( h))h = dH;
			if( isNaN( s))s = dS;
		}

		return [h, s, v];
	},

/**
* 
*/
	hsv2rgb: function( HSVorH, S, L){
		if( typeof( arguments[0]) == "object"){
			var hsl = arguments[0];
		}else{
			var hsl = arguments;
		}
		var h = hsl[0];
		var s = hsl[1];
		var v = hsl[2];

		while( h > 360)h -= 360;
		while( h < 0)h += 360;

		if( s < 0)s = 0;
		if( s > 255)s = 255;

		if( v < 0)v = 0;
		if( v > 255)v = 255;

		if( v == 0){
			s = 255;
		}
		if ( s == 0 ){                      //HSV values = 0  1
			var r = v;
			var g = v;
			var b = v;
		}else{
			s = s /255;
//			v = v /255;
		
		//	h = h /360;
			var vh = h /60;
			if( vh == 6)vh = 0;
			var i = Math.floor( vh);
			var v1 = Math.round( v *( 1 -s));
			var v2 = Math.round( v *( 1 -s *( vh -i)));
			var v3 = Math.round( v *( 1 -s *( 1 -( vh -i))));
			
			switch ( i){
			case 0:
				var r = v;  var g = v3; var b = v1;
				break;
			case 1:
				var r = v2; var g = v;  var b = v1;
				break;
			case 2:
				var r = v1; var g = v;  var b = v3;
				break;
			case 3:
				var r = v1; var g = v2; var b = v;
				break;
			case 4:
				var r = v3; var g = v1; var b = v;
				break;
			case 5:
				var r = v;  var g = v1; var b = v2;
				break;
			}
		
//			var r = r *255;                 //RGB results = 0  255
//			var g = g *255;
//			var b = b *255;
		}
		return [ r, g, b];
	},






/**
* Solves a color from RGB, RGBA, Hex or name to a JSAX.Color object. Alpha is 255 (fully visible) if not set
*
* @param Mixed HexNameArrayOrRed - This value can be a 3/4, 6/7, 8/9 digits long hex string, a colorName or the value for red
* @param Number [Green] - This value is for the green (as an integer between 0 and 255) if you use the R,G,B or R,G,B,A mode.
* @param Number [Blue] - The value between 0 and 255 for blue
* @param Number [[Alpha]] - The value between 0 and 255 for blue (is don't need to set this value if you use the R,G,B mode)
*
* @return Object - JSAX.Color object
*
* @example JSAX.Color.solv( "tomato")
* @example JSAX.Color.solv( "#FD6347")
* @example JSAX.Color.solv( "#FD6347AA")
* @example JSAX.Color.solv( 253, 99, 71)
* @example JSAX.Color.solv( [253, 99, 71])
* @example JSAX.Color.solv( "253, 99, 71")
* @example JSAX.Color.solv( 253, 99, 71, 170)
* @example JSAX.Color.solv( [253, 99, 71, 170])
* @example JSAX.Color.solv( "253, 99, 71, 170")
*/
	solv: function( color){
		var hex = false;
		var rgb = false;
		if( typeof( arguments[2]) == "number"){
			rgb = [];
			for( var i = 0; i < arguments.length; i++){
				rgb.push( arguments[i]);
			}
		}else if( typeof( color) == "string"){
			if( typeof( JSAX.Color.names[color.toLowerCase()]) != "undefined"){
				rgb = JSAX.Color.names[color.toLowerCase()];
			}else{
				rgb = color.split( ",");	
				hex = color.chopBegin( "#");
			}
		}else if( typeof( color) == "object"){
			if( typeof( color.R) != "undefined"){
				rgb = [color.R, color.G, color.B, color.A];
			}else{
				rgb = color;
			}
		}
		if( rgb.length == 3){
			rgb[3] = 255;
		}
		var c = JSAX.object.concat( JSAX.proto.Color);
		if( rgb.length > 2){
			c.R = parseInt( rgb[0]);
			c.G = parseInt( rgb[1]);
			c.B = parseInt( rgb[2]);
			c.A = parseInt( rgb[3]);
		}else if( hex){
			if( hex.length == 3){
				hex += "F";
			}
			if( hex.length == 6){
				hex += "FF";
			}
			if( hex.length > 4){
				var hr = hex.substr( 0, 2);
				var hg = hex.substr( 2, 2);
				var hb = hex.substr( 4, 2);
				var ha = hex.substr( 6, 2);
			}else{
				var hr = hex.substr( 0, 1);
				var hg = hex.substr( 1, 1);
				var hb = hex.substr( 2, 1);
				var ha = hex.substr( 3, 1);
			}
			c.R = JSAX.code.hex2dec( hr);
			c.G = JSAX.code.hex2dec( hg);
			c.B = JSAX.code.hex2dec( hb);
			c.A = JSAX.code.hex2dec( ha);
		}else{
			
		}
		var vars = ["R", "G", "B", "A"];
		for( var i = 0; i < vars.length; i++){
			if( c[vars[i]] > 255){
				c[vars[i]] = 255;
			}else if( c[vars[i]] < 0){
				c[vars[i]] = 0;
			}
		}

		c.HSL = JSAX.Color.rgb2hsl( c.R, c.G, c.B, color.H, color.S);
		c.L = c.HSL[2];
		c.HSV = JSAX.Color.rgb2hsv( c.R, c.G, c.B, color.H, color.S);
		c.H = c.HSV[0];
		c.S = c.HSV[1];
		c.V = c.HSV[2];

		/*
		if( c.R == MAX){
			c.H = ( 0 +( ( c.G -c.B) /( MAX -MIN))) *60;
		}
		if( c.G == MAX){
			c.H = ( 2 +( ( c.B -c.R) /( MAX -MIN))) *60;
		}
		if( c.B == MAX){
			c.H = ( 4 +( ( c.R -c.G) /( MAX -MIN))) *60;
		}
		if( c.H < 0){
			c.H = c.H + 360;
		}
		*/

		c.C = Math.max(c.R, c.G, c.B) -Math.min(c.R, c.G, c.B);

		c.HEX = "#"+
			JSAX.code.zeroFill( JSAX.code.dec2hex( c.R), 2)+
			JSAX.code.zeroFill( JSAX.code.dec2hex( c.G), 2)+
			JSAX.code.zeroFill( JSAX.code.dec2hex( c.B), 2);
		c.HEXA = c.HEX+
			JSAX.code.zeroFill( JSAX.code.dec2hex( c.A), 2);

		return c;
	},

	solvHSV: function( HSVorH, S, L, A){
		var c = false;
		if( typeof( arguments[0]) == "object"){
			var hsv = arguments[0];
		}else{
			var hsv = arguments;
		}
		if( hsv.HSV){
			c = JSAX.object.concat( hsv);
		}else{
			c = {};
			c.H = hsv[0];
			c.S = hsv[1];
			c.V = hsv[2];
			if( typeof( hsv[3]) != "undefined"){
				c.A = hsv[3];
			}
		}

		var rgb = JSAX.Color.hsv2rgb( c.H, c.S, c.V);

		c.R = rgb[0];
		c.G = rgb[1];
		c.B = rgb[2];

//		alert( r+" "+g+" "+b);
		return JSAX.Color.solv( c);

	},

	solvHSL: function( HSLorH, S, L, A){
		if( typeof( arguments[0]) == "object"){
			var hsl = arguments[0];
		}else{
			var hsl = arguments;
		}
		if( hsv.HSL){
			var h = hsl.H;
			var s = hsl.S;
			var l = hsl.C;
		}else{
			var h = hsl[0];
			var s = hsl[1];
			var l = hsl[2];
		}

		var rgb = JSAX.Color.hsl2rgb( h, s, l);

		if( hsv.HSL){
			rgb[3] = rgb.A;
		}else if( typeof( hsv[3]) != "undefined"){
			rgb[3] = hsv[3];
		}else{
			rgb[3] = 255;
		}
//		alert( r+" "+g+" "+b);
		return JSAX.Color.solv( rgb);
	},

	solvXYZ: function( XYZorX, Y, Z, A){
		if( typeof( arguments[0]) == "object"){
			var xyz = arguments[0];
		}else{
			var xyz = arguments;
		}
		var X = hsv[0];
		var Y = hsv[1];
		var Z = hsv[2];

		X = X /100;        //Where X = 0   95.047
		Y = Y /100;        //Where Y = 0  100.000
		Z = Z /100;        //Where Z = 0  108.883

		var R = X *  3.2406 +Y * -1.5372 +Z * -0.4986;
		var G = X * -0.9689 +Y *  1.8758 +Z *  0.0415;
		var B = X *  0.0557 +Y * -0.2040 +Z *  1.0570;
		
		if( R > 0.0031308){
			R = 1.055 *( R ^( 1 /2.4)) -0.055;
		}else{
			R = 12.92 *R;
		}

		if( G > 0.0031308){
			G = 1.055 *( G ^( 1 /2.4)) -0.055;
		}else{
			G = 12.92 *G;
		}

		if( var_B > 0.0031308){
			B = 1.055 *( B ^( 1 /2.4)) -0.055;
		}else{
			B = 12.92 *B;
		}
		
		var R = R *255;
		var G = G *255;
		var B = B *255;

		if( typeof( hsv[3]) != "undefined"){
			var A = xyz[3];
		}else{
			var A = 255;
		}
		return JSAX.Color.solv( R, G, B, A);
	},

/**
* This function solves your color and inverts it without changing the alpha value.
*
* @param Mixed HexNameOrRed - This value can be a 3/4, 6/7, 8/9 digits long hex string, a colorName or the value for red
* @param Number [Green] - This value is for the green (as an integer between 0 and 255) if you use the R,G,B or R,G,B,A mode.
* @param Number [Blue] - The value between 0 and 255 for blue
* @param Number [[Alpha]] - The value between 0 and 255 for blue (is don't need to set this value if you use the R,G,B mode)
*
* @return Object - The inverted JSAX.Color object
*
* @example JSAX.Color.invert( "tomato")
* @example JSAX.Color.invert( "#FD6347")
* @example JSAX.Color.invert( "#FD6347AA")
* @example JSAX.Color.invert( [253, 99, 71])
* @example JSAX.Color.invert( 253, 99, 71, 170)
*/
	invert: function(){
		var color = JSAX.Color.solv( arguments[0], arguments[1], arguments[2], arguments[3]);
		color = color.invert();
		return color;
	},

/**
* This function solves your color and inverts it without changing the alpha value.
*
* @param Mixed color1 - The starting color of the range
* @param Mixed color2 - The ending color of the range
* @param Number steps - The number of steps the range shold be devided in
*
* @return Array - A list of JSAX.Color objects of your range
*
* @example JSAX.Color.makeRange( [240, 200, 150], "#00CCFF", 5)
*/
	makeRange: function( color1, color2, steps){
		var c1 = JSAX.Color.solv( color1);
		var c2 = JSAX.Color.solv( color2);
		var cDif = {	R: parseFloat( ( c2.R -c1.R) /( steps -1)),
				G: parseFloat( ( c2.G -c1.G) /( steps -1)),
				B: parseFloat( ( c2.B -c1.B) /( steps -1)),
				A: parseFloat( ( c2.A -c1.A) /( steps -1))};
		var range = [c1];
		for( var s = 1; s < steps; s++){
			range.push( JSAX.Color.solv(
				c1.R +parseInt( cDif.R *s),
				c1.G +parseInt( cDif.G *s),
				c1.B +parseInt( cDif.B *s),
				c1.A +parseInt( cDif.A *s)));
		}
//		alert( cDif.R+" "+cDif.G+" "+cDif.B+" "+cDif.A+" = ");
		return range; // range from color1 to color 2
	}

// some more functions
};









/**
* The JSAX.Color object prototype, containing Red, Green, Blue, Alpha, the hexadecimal colorcode, the hexadecimal colorcode with alpha and some color functions.
*
* @parent JSAX.proto.Color
*
* @example JSAX.Color.solv( "#FFFFFFFF")
*/
JSAX.proto.Color = { 

	R: 255,
	G: 255,
	B: 255,

	HEX: "#FFFFFF",

	C: 255,

	H: 360,
	S: 255,
	L: 255,

	V: 255,


	A: 255,

	HEXA: "#FFFFFFFF",

/**
* Returns the a copy of the color object with inverted colors
*
* @return Object - JSAX.Color object
*
* @example JSAX.Color.solv( "#FFAA22").invert()
*/
	invert: function(){
		var c = JSAX.object.concat( this);
		c.R = 255 -c.R;
		c.G = 255 -c.G;
		c.B = 255 -c.B;
		return JSAX.Color.solv( c);
	},

/**
* Returns the a copy of the color object with red set to your value
*
* @param Number dec - The value between 0 and 255 you want to set red to
*
* @return Object - JSAX.Color object
*
* @example JSAX.Color.solv( "#FFAA22").setR( 100)
*/
	setR: function( dec){
		var c = JSAX.object.concat( this);
		c.R = dec;
		return JSAX.Color.solv( c);
	},

/**
* Returns the a copy of the color object with green set to your value
*
* @param Number dec - The value between 0 and 255 you want to set green to
*
* @return Object - JSAX.Color object
*
* @example JSAX.Color.solv( "#FFAA22").setG( 255)
*/
	setG: function( dec){
		var c = JSAX.object.concat( this);
		c.G = dec;
		return JSAX.Color.solv( c);
	},

/**
* Returns the a copy of the color object with blue set to your value
*
* @param Number dec - The value between 0 and 255 you want to set blue to
*
* @return Object - JSAX.Color object
*
* @example JSAX.Color.solv( "#FFAA22FF").setB( 200)
*/
	setB: function( dec){
		var c = JSAX.object.concat( this);
		c.B = dec;
		return JSAX.Color.solv( c);
	},

/**
* Returns the a copy of the color object with alpha set to your value
*
* @param Number dec - The value between 0 and 255 you want to set alpha to
*
* @return Object - JSAX.Color object
*
* @example JSAX.Color.solv( "#FFAA22FF").setA( 150)
*/
	setA: function( dec){
		var c = JSAX.object.concat( this);
		c.A = dec;
		return JSAX.Color.solv( c);
	},

/**
* Returns the a copy of the color object with ajusted brightness
*
* @param Number int - The value between 0 and 255 of light you want to set the brightness to
*
* @return Object - JSAX.Color object
*
* @example JSAX.Color.solv( "#FFAA22").setL( 100)
*/

	setL: function( dec){
		var dec = parseInt( dec);
		if( dec > 255)dec = 255;
		if( dec < 0)dec = 0;
		return this.light( dec -this.L);
	},

/**
* Returns the a copy of the color object with ajusted brightness
*
* @param Number int - The value between -255 and 255 of light you want to add /subtract
*
* @return Object - JSAX.Color object
*
* @example JSAX.Color.solv( "#FFAA22").light( 100)
* @example JSAX.Color.solv( "#FFAA22").light( -100)
*/
	light: function( add){
		return JSAX.Color.solv( ( this.R +add), ( this.G +add), ( this.B +add), this.A);
		var n = add *3;
		var c = JSAX.object.concat( this);
		var sum = c.R +c.G +c.B;
		if( add < 0){
			c.R = this.R;
			c.G = this.G;
			c.B = this.B;
		}else{
			c.R = 255 -this.R;
			c.G = 255 -this.G;
			c.B = 255 -this.B;
		}
		
		var sum2 = c.R +c.G +c.B;
		if( sum2 < 1){
			return JSAX.Color.solv( this.HEXA);
		}


		// alert( sum2);
		if( add < 0)n += -n *2;
		c.R = ( n /3 /255) *( sum2 /3 /255 *c.R);
		c.G = ( n /3 /255) *( sum2 /3 /255 *c.B);
		c.B = ( n /3 /255) *( sum2 /3 /255 *c.B);
		if( add < 0){
			c = [( this.R -c.R), ( this.G -c.G), ( this.B -c.B), this.A];
		}else{
			c = [( this.R +c.R), ( this.G +c.G), ( this.B +c.B), this.A];
		}
		return JSAX.Color.solv( c);
		var c2 = {"R": 255, "G": this.G, "B": this.B};
		var k = "R";
		var d = false;
		while( !d){
			if( c[k] < 255 && c[k] > 0){
				if( add < 0){
					c[k]--;
					n++;
				}else{
					c[k]++;
					n--;
				}
			}
			if( k == "R"){
				k = "G";
			}else if( k == "G"){
				k = "B";
			}else{
				k = "R";
			}
			if( c.R +c.G +c.B <= 0
			|| c.R +c.G +c.B >= 255 *3
			|| n == 0){
				d = true;
			}
		}
		return JSAX.Color.solv( c.R, c.G, c.B, this.A);
	},



	setH: function( dec){
		var c = JSAX.object.concat( this);
		c.H = dec;
		return JSAX.Color.solvHSV( c);
	},
	setS: function( dec){
		var c = JSAX.object.concat( this);
		c.S = dec;
		return JSAX.Color.solvHSV( c);
	},
	setV: function( dec){
		var c = JSAX.object.concat( this);
		c.V = dec;
		return JSAX.Color.solvHSV( c);
	},
	setC: function( dec){
		var c = JSAX.object.concat( this);
		c.C = dec;
		return JSAX.Color.solvHSL( c);
	},
	setL: function( dec){
		var c = JSAX.object.concat( this);
		c.L = dec;
		return JSAX.Color.solvHSL( c);
	}

};





















