/**
* DOMinfo
* a live DOM index browsing system
* written by Florian Sax 20060126
*
* Copyright (C) 2006 Florian Sax <flosax(at)users.sourceforge.net>
* DOMinfo is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*/

if( !window.JSAX){
	alert( "DOMinfo is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}
JSAX.JSload.dir = "./objects";
require( "DOM", "proto/String", "proto/Number", "Event", "OutPut", "WFM");


JSAX.DOMinfo = {
	Version: 20060228,

	config: {
		plusMinus: ["+ ", "- "],
		equal:     " = ",
		cascades:  {
			"number":   ["(", ")"],
			"string":   ["'", "'"],
			"array":    ["[", "]"],
			"object":   ["{", "}"],
			"error":    ["error{", "}"],
			"function": ["function(){", "};"],
			"element":  ["<", ">"]},
		funcs:  {
			"number":   "JSAX.DOMinfo.makeInfoElem",
			"string":   "JSAX.DOMinfo.makeInfoElem",
//			"array":    "JSAX.DOMinfo.makeInfoElem",
//			"element":  "JSAX.DOMinfo.makeInfoElem",
//			"object":   "JSAX.DOMinfo.makeInfoElem",
			"error":    "JSAX.DOMinfo.makeErrorInfo",
			"function": "JSAX.DOMinfo.makeFunctionInfo"},
		textLimit: 32,
		textFollow: "...",

		toBeEscaped: ["/", "\\", ",", ".", "#", ":", ":", "?", "=", "\t", "\n", " ", "+", "-", "<", ">", "&", "!", "function", "return", "typeof"]
	},


overElem: function( e){
	var event = JSAX.Event.solv( e);
	var elem = event.target;

	return;
},
clickElem: function( e){
	var event = JSAX.Event.solv( e);
	var elem = event.target;
	JSAX.Event.preventAction( e);

	while( elem.parentNode && !elem.title){
		elem = elem.parentNode;
	}
	if( event.altKey && event.ctrlKey && event.shiftKey){
		elem.parentNode.removeChild( elem);
		return;
	}
	if( event.shiftKey && !event.ctrlKey && !event.altKey && elem.DOMpath){
		byId( "DOMpathInput").value = elem.DOMpath;
		byId( "DOMpathInput").form.onsubmit();
		return;
	}
	if( event.ctrlKey && !event.altKey && !event.shiftKey && elem.DOMpath && JSAX.WFM){
		JSAX.WFM.open( elem);
		return;
	}
	if( !JSAX.DOMinfo.config.cascades[elem.objType]){
		return;
	}

	if( !elem.DOMpath){
		return;
	}
	JSAX.OutPut.show( "processing node ("+elem.DOMpath+") ...");
//	document.body.style.cursor = "wait";
//	getObjByElem( elem, event);
	JSAX.DOMinfo.myEvent = event;
	JSAX.DOMinfo.myElement = elem;
	setTimeout( "JSAX.DOMinfo.loadIntoElem( JSAX.DOMinfo.myElement);", 200);
	
},

mustBeEscaped: function( DOMpath){
	for( var i=0; i < JSAX.DOMinfo.config.toBeEscaped.length; i++){
		if( DOMpath.indexOf( JSAX.DOMinfo.config.toBeEscaped[i]) != -1){
			return true;
		}
	}
	return false;
},

objectType: function( obj){
//	return typeof( obj); // enable this line to disable the array
	if( obj === null){
		return "null";
	}
	if( typeof( obj) == "undefined"){
		return "undefined";
	}
	if( typeof( obj) == "object"){
		if( typeof( obj.tagName) == "string"){
			str = "element";
		}else if( obj instanceof Array){
			str = "array";
		}else{
			str = typeof( obj);
		}
	}else{
		str = typeof( obj);
	}
	return str;
},


/**
* opens a DOMinfo cascade object
*/
loadIntoElem: function( elem){
	var elem = elem;
	var event = JSAX.DOMinfo.myEvent;
	if( !elem.DOMpath){
		return;
	}

	if( elem.getElementsByTagName( "DIV").length){
//		elem.innerHTML = JSAX.DOMinfo.config.plusMinus[0]+elem.innerHTML.chopBegin( JSAX.DOMinfo.config.plusMinus[1]);
		elem.parentNode.insertBefore( JSAX.DOMinfo.makeElem( elem.DOMpath), elem);
		elem.parentNode.removeChild( elem);
//		elem.removeChild( elem.getElementsByTagName( "DIV")[0]);
		setTimeout( "JSAX.OutPut.hide();", 100);
		return;
	}

	var pos = elem.innerHTML.pos( JSAX.DOMinfo.config.plusMinus[0]);
	var len = JSAX.DOMinfo.config.plusMinus[0].length;
	pos = len;
	elem.innerHTML = JSAX.DOMinfo.config.plusMinus[1]+elem.innerHTML.substr( pos);
	if( JSAX.DOMinfo.config.cascades[elem.objType]){
		pos = elem.innerHTML.pos( JSAX.DOMinfo.config.equal);
		elem.innerHTML = elem.innerHTML.substr( 0, pos)+
			JSAX.DOMinfo.config.equal.txt2html()+
			JSAX.DOMinfo.config.cascades[elem.objType][0].txt2html();
	}

	var done = false;
	var container = document.createElement( "DIV");
	if( elem.object == null){
		container.className = "DOMinfo_null";
		container.innerHTML = "null";
		done = true;
	}else{
//	alert( elem.objType+"="+elem.object)
		container.className = "DOMinfo_container";
		if( elem.objType == "function"){
			container.appendChild( JSAX.DOMinfo.makeFunctionInfo( elem));
//			done = true;
		}else if( elem.objType == "error"){
			if( typeof( elem.object) == "string"){
				elem.objType = "string";
			}
			container.appendChild( JSAX.DOMinfo.makeInfoElem( elem));
//			container.appendChild( JSAX.DOMinfo.makeErrorInfo( elem));
//			done = true;
		}else if( elem.objType == "number" || elem.objType == "string"){
			container.appendChild( JSAX.DOMinfo.makeInfoElem( elem));
		}
	}
/*
		if( objType == "string"){
			if( elem.object.length > 8){
				container.appendChild( JSAX.DOMinfo.makeInfoElem( elem.DOMpath));
				var objs = 3;
			}else{
				var objs = elem.object.length;
			}
			for( var i=0; i< objs; i++){
				container.appendChild( JSAX.DOMinfo.makeElem( elem.DOMpath+"["+i+"]"));
			}
		}*/
//			alert( elem.object.constructor);

			
	if( !done)for( var property in elem.object){
		JSAX.OutPut.show( "processing node ("+elem.DOMpath+"["+property+"]) ...");
		if( elem.objType == "string" && property.toString().canBeANumber()){
			continue;
		}
		container.appendChild( JSAX.DOMinfo.makeElem( elem, property));
	}

	elem.appendChild( container);

	if( JSAX.DOMinfo.config.cascades[elem.objType]){
		var innerDiv = document.createElement( "div");
 		innerDiv.innerHTML = JSAX.DOMinfo.config.cascades[elem.objType][1];
		elem.appendChild( innerDiv);
	}

	setTimeout( "JSAX.OutPut.hide();", 100);
//	document.body.style.cursor = "";
},

makeFunctionInfo: function( DOMpath){
	if( typeof( DOMpath) == "object"){
		var DOMpath = DOMpath.DOMpath;
	}
	var myDOMpath = JSAX.DOMinfo.promptArguments( DOMpath);

	var container = document.createElement( "DIV");
//	container.className = "DOMinfo_funcInfo";
	var elem = JSAX.DOMinfo.makeElem( myDOMpath);
//	elem.innerHTML = "RETURN: "+elem.innerHTML;

	container.appendChild( elem);
	container.appendChild( JSAX.DOMinfo.makeInfoElem( DOMpath));

	return container;
},

callFunc: function( DOMpath){
	if( typeof( DOMpath) == "object"){
		var DOMpath = DOMpath.DOMpath;
	}
	var lastPos = DOMpath.rpos( ")");
	if( lastPos != -1 && lastPos < 2){
		JSAX.DOMinfo.myDOMpath = DOMpath;
		return eval( DOMpath);
	}else{
		return eval( JSAX.DOMpath.promptArguments( DOMpath));
	}
},

promptArguments: function( DOMpath){
	var args = prompt( "Enter\ncommaseperated argunents for function\n"+DOMpath+"(", '"string1", "string2"');
	if( args === null){
		args = "";
	}

	return DOMpath+"("+args+")";
},

makeInfoElem: function( DOMpath){
	if( typeof( DOMpath) == "object"){
		var DOMpath = DOMpath.DOMpath;
	}
	var objType	= false;
	var string	= "null";
	try{
		var object	= eval( DOMpath);
	}catch( e){
		string	= e.message;
		objType	= "error";
	}

	if( objType == false){
		objType	= JSAX.DOMinfo.objectType( object);
		if( objType == "undefined"){
			string = "undefined";
		}else if( objType == "function"){
			string = DOMpath+" == "+object.toString().trim();
		}else if( JSAX.DOMinfo.config.cascades[objType]){
			string = objType+" "+
			JSAX.DOMinfo.config.cascades[objType][0]+
			object.toString()+
			JSAX.DOMinfo.config.cascades[objType][1];
		}
	}

	var elem	= document.createElement( "DIV");
	elem.className	= "DOMinfo_info";

//	alert( object.toString());
//	alert( string);

	elem.innerHTML	= string.txt2html();
	elem.title	= objType+" "+DOMpath;
	return elem;
},

makeErrorInfo: function( elem){
	var container = document.createElement( "DIV");
	container.className = "DOMinfo_container";

	if( typeof( elem.object) != "undefined"){
		for( var key in elem.object){
			container.appendChild( JSAX.DOMinfo.makeElem( elem.DOMpath+'["'+key+'"]'));
		}
	}else{
		container.innerHTML = "Could not track error";
	}
	return container;
},

error: [],

makeElem: function( DOMpathOrElem, child){
	var elem = document.createElement( "DIV");
	
	if( typeof( DOMpathOrElem) == "object" && child){

		var txtDOMpath = DOMpathOrElem.DOMpath;
		if( txtDOMpath.pos( ";") != -1){
			txtDOMpath = txtDOMpath.substring( txtDOMpath.lpos( ";")+1 ).trim();
		}

		if( child.canBeANumber()){
			txtDOMpath += '['+child+']';
		}else if( JSAX.DOMinfo.mustBeEscaped( child)){
			txtDOMpath += '["'+child+'"]';
		}else{
			txtDOMpath += '.'+child;
		}
		elem.DOMpath = txtDOMpath;

		try{
			elem.object = DOMpathOrElem.object[child];
		}catch( e){
			elem.object = e;
			elem.objType = "error";
			if( typeof( e) == "object"){
				var errorTxt = e.message;
			}else{
				var errorTxt = e;
			}
		}
	}else{
		elem.DOMpath	= DOMpathOrElem.chopEnd( ";");
		var txtDOMpath = elem.DOMpath;
		try{
			elem.object	= eval( elem.DOMpath);
		}catch( e){
			elem.object = e;
			elem.objType = "error";
			if( typeof( e) == "object"){
				var errorTxt = e.message;
			}else{
				var errorTxt = e;
			}
		}
	}
	if( !elem.objType){
		elem.objType	= JSAX.DOMinfo.objectType( elem.object);
	}
	elem.className	= "DOMinfo_"+elem.objType;
	var txt = "";
	if( elem.objType == "null"
	 || elem.objType == "undefined"){
		txt = elem.objType;
	}else if( elem.objType == "error"){
		txt = errorTxt;

		// catch error
		var n = JSAX.DOMinfo.error.length;
		JSAX.DOMinfo.error.push( elem.object);
		elem.DOMpath = 'JSAX.DOMinfo.error['+n+']';

	}else if( elem.objType == "function"){
	}else if( elem.objType == "element"){
		txt = elem.object.tagName
	}else{
		try{
			txt = elem.object.toString();
		}catch( e){
			try{
				txt = elem.object+"";
			}catch( e){
				txt = "";
			}
		}
		if( typeof( txt) == "string"){
			txt = txt.chopBegin( "[").chopBegin( "object ").chopEnd( "]");
		}else{
			txt = "";
		}
	}

	if( txt.length > JSAX.DOMinfo.config.textLimit){
		txt = txt.substring( 0, JSAX.DOMinfo.config.textLimit -JSAX.DOMinfo.config.textFollow.length)+
			JSAX.DOMinfo.config.textFollow;
	}

	var HTML = txtDOMpath+JSAX.DOMinfo.config.equal;
	var pmSign = JSAX.DOMinfo.config.plusMinus[0];
	elem.style.cursor = "default";
	if( JSAX.DOMinfo.config.cascades[elem.objType]){
		JSAX.DOMinfo.config.cascades[elem.objType][0];
		HTML += JSAX.DOMinfo.config.cascades[elem.objType][0];
		if( txt){
			HTML += txt;
		}
		HTML += JSAX.DOMinfo.config.cascades[elem.objType][1];
		elem.style.cursor = "pointer";
		txt = "";
	}else{
		var sign = "";
		for( var i = 0; i < pmSign.length; i++){
			sign += " ";
		}
		pmSign = sign;
	}
 	if( txt){
		HTML += txt;
	}
	HTML = pmSign+HTML;

	elem.innerHTML = HTML.txt2html();

	elem.title = elem.objType+" "+txtDOMpath;
	elem.onclick = JSAX.DOMinfo.clickElem;

/*	if( elem.objType == "error"){
		elem.DOMpath = "try{ eval( '"+elem.DOMpath+"');}catch( e){ JSAX.DOMinfo.myError = e; }; JSAX.DOMinfo.myError";
	}*/
	return elem;
},

activateElement: function( elem){
	var newElem = JSAX.DOMinfo.makeElem( elem.innerHTML.unescapeHTML());
	newElem.onclick = JSAX.DOMinfo.clickElem;
//	newElem.onmouseover = JSAX.DOMinfo.overElem;
	elem.parentNode.insertBefore( newElem, elem);
	elem.parentNode.removeChild( elem);
},

activate: function( e){
	if( e){
		var event = e;
	}else{
		var event = event;
	}
	JSAX.DOMinfo.myEvent = event;

	var elems = document.getElementsByClassName( "DOMinfo");

	for( var i=0; i < elems.length; i++){
		JSAX.DOMinfo.activateElement( elems[i]);
	}
}

}; 

