/**
* JSAX.TOC - Table Of Contents
* Technic adopdet from quirksmode.org
*/
JSAX.TOC = {
	Version: 20060315,

	elem: false,
/**
* JSAX.TOC.make - Creates a Table Of Content with links to all titles in the document
*/
	make: function(){
		
		if( JSAX.TOC.elem){
			var TOCelem = JSAX.TOC.elem;
			var TOCtitle = TOCelem.childNodes[0];
			var TOCcontainer = TOCelem.childNodes[1];
			TOCcontainer.innerHTML = "";
			
		}else{
			var TOCelem = document.createElement( "div");
			TOCelem.id = "TOC";
	
			var TOCtitle = TOCelem.appendChild(document.createElement( "span"));
			TOCtitle.onclick = function( e){
				if( this.parentNode.lastChild.style.display == "none"){
					this.parentNode.show();
				}else{
					this.parentNode.hide();
				}
				e.cancelBubble = true;
			};
			TOCelem.hide = function( e){
				var title = this.childNodes[0];
				var content = this.lastChild;

				if( this.lastChild.style.display == "none"){
					return;
				}

				var w = content.offsetWidth;
				content.style.width = w+"px";
				var d = w -content.offsetWidth;
				w += d;
				content.style.width = w+"px";
				title.style.width = w+"px";
				content.style.display = "none"
			};
			TOCelem.show = function( e){
				var title = this.childNodes[0];
				var content = this.lastChild;

				title.style.width = "";
				content.style.width = "";
				content.style.display = "";
			}
			TOCtitle.innerHTML = "Contents";
	
			var TOCcontainer = TOCelem.appendChild( document.createElement( "div"));
//			window.onclick = function(){
//				TOCelem.hide();
//			}

		}
		TOCcontainer.style.display = "none";

		var allElems = document.body.getElementsByTagName( "*");
		var headLines = [];
		for( var i=0; i < allElems.length; i++){
			var test = allElems[i].nodeName.indexOf( "H") +1;
			if( test && allElems[i].nodeName.substring( 1) < 9){
				headLines.push( allElems[i])
			}
		}
		if( headLines.length < 2){
			return false;
		}
	
		for( var i = 0; i < headLines.length; i++){
			var headLine = headLines[i]
	
			var TOClink = document.createElement( "a");
			TOClink.innerHTML = headLine.innerHTML;
			TOClink.href = "#headLine_"+i;
			TOClink.className = "TOC_"+headLine.nodeName;
			TOCcontainer.appendChild( TOClink);
	
			var ScrollLink = document.createElement( "a");
			ScrollLink.id = "headLine_"+i;
			if( headLine.nodeName == "H2"){
	//			TOClink.innerHTML = "Top";
	//			TOClink.href = "#top";
	//			ScrollLink.id = "top";
			}
			headLine.parentNode.insertBefore( ScrollLink, headLine);
		}
		if( !JSAX.TOC.elem){
			document.body.insertBefore( TOCelem, document.body.childNodes[0]);
			JSAX.TOC.elem = TOCelem;
		}
		TOCelem.show();
		TOCelem.hide();
		TOCelem.show();
		setTimeout( "JSAX.TOC.elem.hide();", 200);
		setTimeout( "JSAX.TOC.elem.show();", 201);
		return true;
	}
};




