if( !window.JSAX){
	alert( "colorTool is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}
require( "Color", "Event", "compat/png_alpha");

/**
* colorTool
* 
* written by Florian Sax 20060204
*
* Copyright (C) 2006 Florian Sax <flosax(at)users.sourceforge.net>
* colorTool is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*
* @version 20060217
*
* @example require( "GUI/colorTool/colorTool"); document.body.insertBefore( JSAX.colorTool.make( function( c){ document.body.style.backgroundColor = c.HEX;}), document.body.childNodes[0]); document.body.childNodes[0];
*/
JSAX.colorTool = {
	Version: 20060228,

	defaultColor: "#FFFFFF",
	inputs: [
		["hex", "HEX", "solv", 7, "#000000", "#FFFFFF"],
		{	"tagName": "p",
			"innerHTML": "<br/>RGB"},
		["red", "R", "setR", 3, 0, 255, 0.5],
		["green", "G", "setG", 3, 0, 255, 0.5],
		["blue", "B", "setB", 3, 0, 255, 0.5],
		{	"tagName": "span",
			"innerHTML": "<br/><span style='background: #C0C0C0; border: 1px solid black; padding: 2px 10px 2px 10px; cursor: pointer;' title='Invert RGB'>invert</span>",
			onclick: function( e){
				this.form.C = this.form.C.invert();
				this.form.applyColor( false);
			}},
		{	"tagName": "p",
			"innerHTML": "<br/>HSV"},
		["hue", "H", "setH", 3, -259, 719, 0.5],
		{	"tagName": "span",
			"innerHTML": "<br/><span style='background: #C0C0C0; border: 1px solid black; padding: 2px 10px 2px 10px; cursor: pointer;' title='Invert Hue'>invert</span>",
			onclick: function( e){
				this.form.C = this.form.C.setH( this.form.C.H +180);
				this.form.applyColor( false);
			}},
		{
			"tagName": "div",
			"title": "Hue",
			"width": 255,
			"height": 20,
			"innerHTML": "<img style='cursor: crosshair; height: 20px; width: 255px; border: 1px solid black;' src='"+JSAX.JSload.dir+"GUI/colorTool/pics/hue.png'/><img style='position: absolute; z-index: 1; cursor: pointer;' src='"+JSAX.JSload.dir+"GUI/colorTool/pics/cursor.gif'/>",
			onmousedown: function ( e){
				JSAX.colorTool.activElem = this;
				document.body.onmousemove = this.move
				document.body.onmouseup = function( e){
					JSAX.colorTool.activElem.move( e);
					JSAX.colorTool.activElem = false;
					document.body.onmousemove = null;
					document.body.onmouseup = null;
					return JSAX.Event.preventAction( e);
				};
				return this.move( e);
			},
			move: function( e){
				var event = JSAX.Event.solv( e);
				var elem = JSAX.colorTool.activElem;
				var h = (( event.clientX -elem.offsetLeft) /elem.childNodes[0].offsetWidth) *360;
				h = Math.round( h);
				elem.form.C = elem.form.C.setH( h);
				elem.form.applyColor( false);
				return JSAX.Event.preventAction( e);
			},
			update: function(){
				var h = this.form.C.H /360;
				while( h > 1)h -= 1;
				while( h < 0)h += 1;
				h = h *this.childNodes[0].offsetWidth;
				h -= this.childNodes[1].offsetWidth /2;
				var y = this.childNodes[0].offsetHeight /2;
				y -= this.childNodes[1].offsetHeight /2;
				h = Math.ceil( h);
				y = Math.ceil( y);
				this.childNodes[1].style.top = y+"px";
				this.childNodes[1].style.left = h+"px";
			}
		},
		["saturation", "S", "setS", 3, 0, 255, 0.5],
		["value", "V", "setV", 3, 0, 255, 0.5],
		{
			"tagName": "div",
			"title": "(H)S V",
			"height": "255",
			"width": "255",
			"innerHTML": "<img style='cursor: crosshair; height: 255px; width: 255px; border: 1px solid black;' src='"+JSAX.JSload.dir+"GUI/colorTool/pics/SV.png'/><img style='position: absolute; z-index: 1; cursor: pointer;' src='"+JSAX.JSload.dir+"GUI/colorTool/pics/cursor.gif'/>",
			onmousedown: function ( e){
				JSAX.colorTool.activElem = this;
				document.body.onmousemove = this.move
				document.body.onmouseup = function( e){
					JSAX.colorTool.activElem.move( e);
					JSAX.colorTool.activElem = false;
					document.body.onmousemove = null;
					document.body.onmouseup = null;
					return JSAX.Event.preventAction( e);
				};
				return this.move( e);
			},
			move: function( e){
				var event = JSAX.Event.solv( e);
				var elem = JSAX.colorTool.activElem;
				var s = (( elem.childNodes[0].offsetHeight -( event.clientY -elem.offsetTop)) /elem.childNodes[0].offsetHeight);
				var v = (( event.clientX -elem.offsetLeft) /elem.childNodes[0].offsetWidth);
				if( s < 0)s = 0;
				if( s > 1)s = 1;
				if( v < 0)v = 0;
				if( v > 1)v = 1;
				s = Math.round( s *255);
				v = Math.round( v *255);
//				alert( s+" "+v);
				elem.form.C = elem.form.C.setS( s).setV( v);
//				alert( X+" x "+Y);
				elem.form.applyColor( false);
				return JSAX.Event.preventAction( e);
			},
			update: function(){
//				if( !this.childNodes || this.childNodes.length == 0)return;
				var s = this.form.C.S /255;
				var v = this.form.C.V /255;
				s = Math.round( s *this.childNodes[0].offsetHeight);
				v = Math.round( v *this.childNodes[0].offsetWidth);
				s = this.childNodes[0].offsetHeight -s;
				s -= Math.floor( this.childNodes[1].offsetHeight /2);
				v -= Math.floor( this.childNodes[1].offsetWidth /2);
				this.childNodes[1].style.top = s+"px";
				this.childNodes[1].style.left = v+"px";
				this.style.backgroundColor = this.form.C.setS( 255).setV( 255).HEX;
			}
		},
		{	"tagName": "p",
			"innerHTML": "<br/>HCL"},
		["hue", "H", "", 3],
		["color", "C", "", 3],
		["ligth", "L", "", 3],
		{	"tagName": "p",
			"innerHTML": "<br/>Alpha"},
		["alpha", "A", "setA", 3, 0, 255, 0.5],
		["hexA", "HEXA", "solv", 9, "#00000000", "#FFFFFFFF"]],

/**
* Creates the colorTool
*
* @parent = JSAX.colorTool
*
* @return Element - The colorTool Element object
*/
	make: function( func){
		if( JSAX.colorTool.elem){
			colorTool = JSAX.colorTool.elem;
		}else{
			var colorTool = document.createElement( "form");
			JSAX.colorTool.elem = colorTool;
			colorTool.id = "JSAXcolorTool";

			if( typeof( func) == "function"){
				colorTool.func = func;
			}else if( typeof( func) == "string"){
				try{
					elem.target = eval( func);
				}catch( e){
					return false;
				}
				colorTool.func = function( c){ elem.target = c.HEX; };
			}else{
				return false;
			}

			colorTool.className = "ColorTool";
			colorTool.innerHTML = "<span id='colorToolPreview' style='heigth: 100px; width: 200px; vertical-align: middle; text-align: center;'>&nbsp;&nbsp;&nbsp;</span></big><br/> ";

			colorTool.inputs = [];
			for( var i = 0; i < JSAX.colorTool.inputs.length; i++){
				var inpt = JSAX.colorTool.makeInput( JSAX.colorTool.inputs[i]);
				colorTool.appendChild( inpt);
				if( inpt.input){
					colorTool.inputs.push( inpt.input);
				}
			}
/**
* @parent JSAX.colorTool.elem
*/
			colorTool.applyColor = function( inpt){

//				alert( this.color["H"]);
				if( typeof( this.C) != "object" || !this.C.HEX){
					this.C = JSAX.Color.solv( JSAX.colorTool.defaultColor);
				}
//				return;
				if( typeof( inpt) == "undefined"){
//					var inputs = this.getElementsByTagName( "input");
					for( var i = 0; i < this.inputs.length; i++){
						if( this.inputs[i].locked || !this.inputs[i].func){
							continue;
						}
						if( this.inputs[i].value != this.C[this.inputs[i].atrib]){
							var inpt = this.inputs[i];
							i = this.inputs.length;
						}
					}
				}

				if( !inpt){

				}else if( inpt.func){
//					alert( input.value+" "+input.func+" "+input.atrib+" "+this.C["H"]);
					var val = JSAX.colorTool.cleanInputValue( inpt);
					if( typeof( this.C[inpt.func]) == "function"){
						this.C = this.C[inpt.func]( val);
					}else{
						this.C = JSAX.Color.solv( val);
					}
				}


				for( var i = 0; i < this.inputs.length; i++){
					if( this.inputs[i].locked
					 && this.inputs[i].value != this.C[this.inputs[i].atrib]){
						this.C = this.C[this.inputs[i].func]( JSAX.colorTool.cleanInputValue( this.inputs[i]));
					}
				}

				for( var i = 0; i < this.inputs.length; i++){
					if( typeof( this.inputs[i].update) == "function"){
						this.inputs[i].update();
					}else{
						this.inputs[i].value = this.C[this.inputs[i].atrib]
					}
				}

				this.childNodes[0].style.backgroundColor = this.C.HEX;
				this.childNodes[0].style.color = this.C.invert().HEX;
				this.childNodes[0].innerHTML = this.C.HEX;
				this.func( this.C);
//				alert( this.C["H"]);
				
			};
			colorTool.onsubmit = function( e){
				JSAX.Event.preventAction( e);
				this.applyColor();
			};
			colorTool.submit = colorTool.onsubmit;
		}
		JSAX.colorTool.elem.applyColor();
		setTimeout( "JSAX.colorTool.elem.applyColor()", 200);
		return colorTool;
	},

/**
* @parent JSAX.colorTool
*/
	cleanInputValue: function( elem){
		if( typeof( elem.value) == "undefined"){
			return;
		}
		if( elem.max > 0 || elem.min > 0){
			var v = parseFloat( elem.value);
			if( !v){
				v = 0;
			}
			if( v > elem.max){
				v == elem.max;
			}
			if( v < elem.min){
				v == elem.min;
			}
			elem.value = v;
		}else{
			v = elem.value;
		}

		return v;
	},

	makeInput: function( inpt){

		var inptCont = document.createElement( "div");

		if( inpt.length == 1){
			return inptCont;
		}

		if( typeof( inpt.tagName) == "string"){
			var elem = document.createElement( inpt.tagName);
			for( var atrb in inpt){
				if( atrb == "tagName"){
					continue;
				}
				if( typeof( inpt[atrb]) != "undefined" || typeof( inpt[atrb]) == "function"){
					elem[atrb] = inpt[atrb];
				}else{
					elem.setAttribute( atrb, inpt[atrb]);
				}
			}
			if( inpt.width){
				elem.style.width = parseInt( inpt.width)+"px";
			}
			if( inpt.width){
				elem.style.height = parseInt( inpt.height)+"px";
			}

			elem.style.position = "relative";
//			elem.setAttribute( "form", JSAX.colorTool.elem);
			elem.form = JSAX.colorTool.elem;
//			alert( elem.formu);
//			alert( JSAX.colorTool.elem);
			inptCont["input"] = elem;
			inptCont.appendChild( elem);
		}else{
			inptCont.innerHTML = inpt[0];
			var elem = document.createElement( "input");
	
			elem.setAttribute( "type", "text");
			elem.setAttribute( "name", inpt[0]);
	
			elem.title = inpt[0];
			elem.atrib = inpt[1];
			elem.func  = inpt[2];
			elem.size  = inpt[3];
			elem.min   = inpt[4];
			elem.max   = inpt[5];
			elem.step  = inpt[6];
			elem.value = elem.max;
			elem.locked = false;
	
			inptCont.input = elem;
	
			inptCont.innerHTML += "&nbsp;";
			elem.onchange = function(){
				this.form.applyColor( this);
			};
	
			if( elem.func && ( elem.max > 0 || elem.min > 0)){
				inptCont.innerHTML += "<input type='checkbox' onchange='this.parentNode.input.locked = ( this.checked ? true : false);'/>";
	
				if( elem.step){
					elem.style.cursor = "crosshair";
	
	//				elem.onkeyup = elem.onchange;
					elem.onmousedown = function( e){
						this.parentNode.lastChild.checked = false;
						this.locked = false;
	
						var event = JSAX.Event.solv( e);
						this.lastX = event.clientX;
						this.lastY = event.clientY;
						JSAX.colorTool.activElem = this;
						document.body.onmousemove = function( e){
							var event = JSAX.Event.solv( e);
							var elem = JSAX.colorTool.activElem;
							var difY = elem.lastY -event.clientY;
							var v = ( (difY < 0) ? -difY : difY) *elem.step;
							if( difY < 0){
								v = parseFloat( elem.value) -v;
							}else{
								v = parseFloat( elem.value) +v;
							}
							if( v < elem.min){
								v = elem.min;
							}
							if( v > elem.max){
								v = elem.max;
							}
							elem.value = v;
							elem.lastX = event.clientX;
							elem.lastY = event.clientY;
							elem.onchange();
							return JSAX.Event.preventAction( e);
						};
						document.body.onmouseup = function( e){
							JSAX.colorTool.activElem.style.backgroundColor = "#FFFFFF";
							JSAX.colorTool.activElem.style.color = "#000000";
//							JSAX.colorTool.activElem = false;
							document.body.onmousemove = null;
							document.body.onmouseup = null;
							return JSAX.Event.preventAction( e);
						};
						this.style.backgroundColor = "#000000";
						this.style.color = "#FFFFFF";
						return JSAX.Event.preventAction( e);
					};
				}
				inptCont.insertBefore( elem, inptCont.childNodes[inptCont.childNodes.length-1]);
			}else{
				if( !elem.func){
					elem.style.cursor = "default";
				}
				inptCont.appendChild( elem);
			}
		}

		return inptCont;
	}

};













