/**
* JSAX.toolBar
* 
* written by Florian Sax 20060213
*
* Copyright (C) 2006 Florian Sax <flosax(at)users.sourceforge.net>
* JSAX.toolBar is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*/

if( !window.JSAX){
	alert( "JSAX.toolBar is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}

require( "DOM", "proto/Element");

JSAX.toolBar = {
	Version: 20060213,

iconDir: "icons/",
iconEnd: ".gif",
timeOut: 3,

getElementByTbID: function( ID){
	var divs = document.body.getElementsByTagName( "DIV");
	for(i = 0; i < divs.length; i++){
		var elem = divs[i];
		if( elem.tbID == ID){
			return elem;
		}
	}
	return false;
},


createAll: function(){
	var divs = document.body.getElementsByTagName( "DIV");
	var items = divs.length;
	for( var i=0; i<items; i++){
		var elem = divs[i];
		if( elem.isClassMember( "toolBar")
		 || elem.isClassMember( "toolBar_v")){
			this.create( elem);
//			alert(elem.id+"\n"+elem.className+"\n"+elem.innerHTML);
		}
	}
},

create: function( toolBar_elem, func){
	var toolBar_elem = toolBar_elem;
	toolBar_elem.unselectable = "on";
	var divs = toolBar_elem.getElementsByTagName( "DIV");
	for( var i=0; i<divs.length; i++){
		var elem = divs[i];
		if( elem.isClassMember( "toolBar_button")){
			var elem = JSAX.toolBar.createButton( elem);
		}else if( elem.isClassMember( "toolBar_sub")){
			var tbText = "";
			if( elem.title){
				tbText = elem.title;
			}

			var hiddenTB = document.createElement( "div");
			hiddenTB.innerHTML = elem.innerHTML;
			if( toolBar_elem.isClassMember( "toolBar")){
				hiddenTB.className = "toolBar_v";
			}else{
				hiddenTB.className = "toolBar";
			}
			hiddenTB.style.position = "absolute";
			hiddenTB.style.zIndex = 99;
			hiddenTB.style.display = "none";
			toolBar_elem.appendChild( hiddenTB);

			elem.innerHTML = tbText;
			JSAX.toolBar.createButton( elem);
			elem.subMenu = hiddenTB;
			elem.onmouseover = function(){
				this.overTime = new Date();
				this.subMenu.onmousemove();
				 return;
			};
			elem.onmouseout = function(){
				 return;
			};
			elem.onclick = function(){
				if( this.subMenu.style.display == "block"){
					this.subMenu.onmouseout();
				}else{
					this.subMenu.onmousemove();
				}
				 return;
			};

			hiddenTB.button = elem;
			hiddenTB.onmousemove = function(){
				this.hideMe = false;
				setTimeout( "JSAX.toolBar.getElementByTbID( '"+this.button.tbID+"').subMenu.onmouseout();", JSAX.toolBar.timeOut *1000);
				var button = this.button;
				button.className = "toolBar_button_over";
				var topPos = button.offsetTop;
				var leftPos = button.offsetLeft
				if( this.isClassMember( "toolBar")){
					leftPos += button.offsetWidth;
				}else{
					topPos += button.offsetHeight;
				}
				topPos += 0;
				leftPos += -2;
				this.style.top = topPos+"px";
				this.style.left = leftPos+"px";
				this.style.display = "block";
				 return;
			};
			hiddenTB.tryHide = function(){
				if( this.hideMe){
					this.button.className = "toolBar_button";
					this.style.display = "none";
					 return;
				}
			};
			hiddenTB.onmouseout = function(){
				this.button.className = "toolBar_button";
				this.style.display = "none";
				 return;
			};
			hiddenTB.style.zIndex = 99;
		}
	}
},

createButton: function( elem){
	if( elem.onmouseover){
		return;
	}
	var ID = elem.innerHTML;
	var text = ID;
	if( window.translations){
		if( window.translations[ID]){
			text = window.translations[ID];
		}
	}

	elem.tbID		= ID;
	elem.title		= text;
	elem.innerHTML	= text;
//	icon.src = "icons/"+ID.toLowerCase()+".gif";
	var icon = new Image();
	icon.buttonElem = elem;
	icon.onload = function(){
		var icon = document.createElement( "img");
		icon.src = this.src;
		icon.title = this.buttonElem.title;
		icon.className = "toolBar_button_icon";
		this.buttonElem.innerHTML = "";
		this.buttonElem.appendChild( icon);
	}
	icon.onerror = function(){
//		alert( "failed to load icon ("+this.src+")");
	}
	icon.onabort = function(){
//		alert( "failed to load icon ("+this.src+")");
	}
	icon.src = JSAX.toolBar.iconDir+ID+JSAX.toolBar.iconEnd;
//	alert( icon.offsetHeight);
	
//	alert( icon.offsetHeight+icon.src);
	
//	elem.style.backgroundimage: icon;


	elem.className = "toolBar_button";
	elem.onmouseover = function(){
		this.className = "toolBar_button_over";
		 return;
	};
	elem.onmouseout = function(){
		this.className = "toolBar_button";
		 return;
	};
	elem.onmousedown = function(){
		this.className = "toolBar_button_down";
		 return;
	};
	elem.onmouseup = function(){
		this.className = "toolBar_button";
		 return;
	};
	if( !elem.onclick){
		elem.onclick = function(){
			this.parentNode.func( this.tbID);
			 return;
		};
	}
	return elem;
}

};

