/*
* JSAX.Opacity - transparent HTML Elements
* This lib is compatibel with Mozilla, InternetExplorer and Khtml, but it somehow does not work in Konqueror
* test with:
require( "Opacity"); JSAX.Opacity.fade( "test", 10, 10)
*
* Copyright (C) 2006 Florian Sax <flosax(at)users.sourceforge.net>
* JSAX.Opacity is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*/


if( !window.JSAX){
	alert( "JSAX.Opacity is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}

require( "proto/Number", "DOM");


JSAX.Opacity = {
	Version: 20060314,

	fadeElemId: 0,
//change the opacity for different browsers
set: function( opacity, id){
	var elem = byId( id);
	if( !elem){
		return false;
	}
	var opacity = parseInt( opacity);
	if( opacity <= 0){
		opacity = 0;
//		JSAX.Opacity.clearSteps( elem);
	}else if( opacity >= 99){
		opacity = 99;
//		JSAX.Opacity.clearSteps( elem);
	}

	if( opacity == 0){
		elem.style.visibility = "hidden";
		elem.style.display = "none";
	}else{
		elem.style.visibility = "";
		elem.style.display = "";
	}

	elem.myOpacity		= opacity;				// Internal
	elem.style.opacity	= ( opacity /100);			// General
	elem.style.MozOpacity	= ( opacity /100);			// Mozilla
	elem.style.filter	= "alpha( opacity="+opacity+")";	// M$IE
	elem.style.KHTMLOpacity	= ( opacity /100);			// KHTML
	elem.style.KhtmlOpacity	= ( opacity /100);
	elem.style.khtmlOpacity	= ( opacity /100);
	return true;
},

clearSteps: function( elem){
	if( !elem.fadeSteps){
		elem.fadeSteps = [];
	}
	for( var i = 0; i < elem.fadeSteps.length; i++){
		clearTimeout( elem.fadeSteps[i]);
	}
	elem.fadeSteps = [];
},

// <a onclick="JSAX.Opacity.fade( 'testElemById', 100, 0, 0.5)">Hide</a>
fadeFrom: function( id, opacStart, opacEnd, sec){
	var elem = byId( id);
	if( !elem){
		return false;
	}
	JSAX.Opacity.clearSteps( elem);
	
	if( opacStart > 100){
		opacStart = 100;
	}
	if( opacStart < 0){
		opacStart = 0;
	}
	if( opacEnd > 100){
		opacEnd = 100;
	}
	if( opacEnd < 0){
		opacEnd = 0;
	}

	var steps = opacEnd.dif( opacStart);
	if( !steps){
		return;
	}
	var msec = sec *1000;
	var tpp = Math.round( msec /steps);

	JSAX.Opacity.set( opacStart, id);

	for( var i = 1; i <= steps; i++){
		if( opacStart < opacEnd){
			var opac = opacStart +i;
		}else{
			var opac = opacStart -i;
		}
		elem.fadeSteps.push( setTimeout( "JSAX.Opacity.set( "+opac+", '"+id+"');", i *tpp));
	}
},

// <a onclick="JSAX.Opacity.shift( 'testElemById', 1);">show/hide</a>
shift: function( id, sec){
	//if an element is invisible, make it visible, else make it ivisible
	var elem = byId( id);
	if( !elem){
		return false;
	}

	if( typeof( elem.myOpacity) == "undefined"){
		elem.myOpacity = 100;
	}

	if( elem.myOpacity == 0){
		JSAX.Opacity.fadeFrom( id, 0, 100, sec);
	}else{
		JSAX.Opacity.fadeFrom( id, 100, 0, sec);
	}
},

// <a onclick="JSAX.Opacity.fade( 'testElemById', 60, 3);">fade to 60%</a>
fade: function( id, opacEnd, sec){
	var elem = byId( id);
	if( !elem){
		return false;
	}

	if( typeof( elem.myOpacity) == "undefined"){
		elem.myOpacity = 100;
	}

	// fade byId from currentOpac to opacEnd in sec
	JSAX.Opacity.fadeFrom( id, elem.myOpacity, opacEnd, sec);
},

hideOnUnfocus: function( elem, sec){
	if( typeof( elem) == "string"){
		var elem = document.getElementById( elem);
	}
	if( typeof( elem) != "object"){
		return false;
	}
	if( !elem.id){
		elem.id = "fadeElem_"+JSAX.Opacity.fadeElemId++;
	}
	elem.onmousemove = function( e){
		JSAX.Opcaity.clearSteps( this);
		JSAX.Opcaity.set( 100, this.id);
	}
	JSAX.Opacity.fadeFrom( elem.id, 100, 0, sec);
},

// <a onclick="JSAX.Opacity.blendImage( 'blendDiv','blendImage', 'testImage.jpg', 0.2);">Image 1</a>
blendImage: function( divId, imageId, imageFile, sec){
	var msec = sec *1000;
	var divElem = byId( divId);
	if( !divElem){
		return false;
	}
	JSAX.Opacity.clearSteps( divElem);
	var imgElem = byId( imageId);
	if( !imgElem){
		return false;
	}

	var speed = Math.round( msec /100);

	//set the current image as background
	divElem.style.backgroundImage = "url( "+imgElem.src+")";

	//make image transparent
	JSAX.Opacity.set( 0, imageId);

	//make new image
	imgElem.src = imageFile;

	//fade in image
	for( var i = 0; i <= 100; i++){
		divElem.fadeSteps.push( setTimeout( "JSAX.Opacity.set( "+i+", '"+imageId+"');", i *speed));
	}
}
};

