if( !window.JSAX){
	alert( "JSAX.benchmark is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}

/**
* JSAX.benchmark
*
* Helps to find out how long things take and how long the take on what browser
* You should compare only with results that had the absolute same conditions (same hoste, same client, same load ...)
* You cannot be shure about the output of benchmark, because it seems as if browsers stack some thing and do them later
* Ajax request have a very inconsistant execution time
*
* written by Florian Sax 20060131
* Copyright (C) 2006 Florian Sax <flosax(at)users.sourceforge.net>
* benchmark is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*
* @version 20060311
*/
JSAX.benchmark = {
	Version: 20060207,
	DocVersion: 20060311,

	testObjects: {},
	times: {},

/**
* A list of all calls which make the benchmark test
*/
	test: {
		StringDefine:            "JSAX.benchmark.testObjects.testString = 'this is a test string wich is not really long!'",
		StringSplit:             "JSAX.benchmark.testObjects.testArray = JSAX.benchmark.testObjects.testString.split( ' ')",

		ArrayJoin:               "JSAX.benchmark.testObjects.testString2 = JSAX.benchmark.testObjects.testArray.join( ',')",

		ElementCreate:           "JSAX.benchmark.testObjects.testElem = document.createElement( 'div')",
		ElementSetId:            "JSAX.benchmark.testObjects.testElem.id = 'testElement'",
		ElementSetClass:         "JSAX.benchmark.testObjects.testElem.className = 'testClass'",
		ElementAppend:           "document.body.appendChild( JSAX.benchmark.testObjects.testElem)",
		ElementInnerHTML:        "JSAX.benchmark.testObjects.testElem.innerHTML = JSAX.benchmark.testObjects.testString2",
		ElementById:             "document.getElementById( 'testElement')",
		ElementByClass:          "document.getElementsByClassName( 'testClass')[0]",

		AjaxRead:                "JSAX.benchmark.testObjects.testFileContent = read( 'pageNotFound')",
		AjaxReadToElement:       "JSAX.benchmark.testObjects.testElem.innerHTML = read( 'pageNotFound2')",

		ElementRemove:           "document.body.removeChild( JSAX.benchmark.testObjects.testElem)"
	},

/**
* JSAX.benchmark.runBenchmarks Runs all everything in JSAX.benchmark.tests
*
* @param Number [tpt] - The minimum time every call should be executed for in milisecounds
* @return Array - A list of the result times.
*
* @example require( 'benchmark'); window.test = JSAX.benchmark.runBenchmarks( 100); test
*/
	runBenchmarks: function( tpt){
		var timeStart = JSAX.benchmark.msec();
		var total = 0;
		for( var key in JSAX.benchmark.test){
			JSAX.benchmark.times[key] = JSAX.benchmark.run( JSAX.benchmark.test[key], tpt);
			total += JSAX.benchmark.times[key];
		}
		JSAX.benchmark.times["TOTAL"] = total;
		JSAX.benchmark.times["TEST_TIME"] = JSAX.benchmark.msec() -timeStart;
		if( tpt){
			return JSAX.benchmark.times;
		}else{
			return JSAX.benchmark.times["TEST_TIME"];
		}
	},

/**
* JSAX.benchmark.runBenchmarks Runs all everything in JSAX.benchmark.tests
*
* @param String call - The command you want to know the execution time of
* @param Number [time] - The minimum execution time in milisecounds
* @return Array - The execution time in milisecs of the call
*
* @example require( "benchmark", "CSV"); JSAX.benchmark.run( "window.test = JSAX.CSV.load( '../saxML/content/adr.csv')")
JSAX.benchmark.run("window.test.join(';;')")
*/
	run: function( call, time){
		var timeStart = JSAX.benchmark.msec();
		if( !time){
			time = 0;
		}
		try{
			eval( call);
		}catch( e){
			return false;
		}
		var i = 1;
		while( time > JSAX.benchmark.msec() -timeStart){
			try{
				eval( call);
			}catch( e){
				time = 0;
				continue;
			}
			i++;
		}
		var allTime = JSAX.benchmark.msec() -timeStart;
		return allTime /i;
	},

/**
* @return Date - A Timestamp with microsecounds
*/
	msec: function(){
		return new Date();
	}
};


