/**
* listWidget class - listWidget.js
* this is a collection of usefull javascript functions
* written by Florian Sax 20051227
*
* @example require( "CSV", "comming/GUI/listWidget");
document.body.insertBefore( JSAX.listWidget.createFromArray( JSAX.CSV.load( "test.csv")), document.body.childNodes[0]);
JSAX.listWidget.activateAll()
* listWidget.js is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*/

require( "Event", "DOM");
JSAX.listWidget = {

	config: {
		list: {
			tagName: "TABLE"
		},
		row: {
			tagName: "TR"
		},
		field: {
			tagName: "TD"
		}
	},

	object: {
		onmousedown: function( e){
			var event = JSAX.Event.solv( e);
			var elem = event.target;
//			alert( (elem.tagName.toUpperCase() == JSAX.listWidget.config.field.tagName));

			if( JSAX.listWidget.isField( elem)
			 && !elem.getElementsByTagName( "input").length){
				var inputElem		= document.createElement( "input");
				inputElem.type		= "text";
				inputElem.onkeypress	= function( e){
					
				};
				inputElem.onblur = function( e){
					var val = this.value;
					this.parentNode.innerHTML = val;
				};
				inputElem.value		= elem.innerHTML;
				var height	= elem.offsetHeight;
				var width	= elem.offsetWidth;
//				var selection	= elem.selection;

				inputElem.style.border	= "1px solid black";
				inputElem.style.margin	= "0px";
				inputElem.style.padding	= "0px";
				inputElem.style.height	= height+"px";
				inputElem.style.width	= width+"px";
				elem.innerHTML		= "";
				elem.appendChild( inputElem);
				try{
			//		inputElem.selection.selectedIndex	= selection.selectedIndex;
					inputElem.focus();
				}catch( e){}
				height		+= height -elem.offsetHeight;
			//	alert( height);
				width		+= width -elem.offsetWidth;
				inputElem.style.height	= height+"px";
				inputElem.style.width	= width+"px";
			//	alert( inputElem.offsetBorder);
			}
		},

		colWidth: [],

		arrangeSize: function(){
			var rows = this.getRows();
			var cols = this.getFields( rows[0]).length;
			var listWidth = JSAX.listWidget.offsetWidth;
			var width = 100;
			if( typeof( JSAX.listWidget.widthCorrection) == "undefined"){
				var firstField = this.getFields( rows[0])[0];
				firstField.style.width = width+"px";
				JSAX.listWidget.widthCorrection = width -firstField.offsetWidth; // border correction
//				JSAX.listWidget.widthCorrection = JSAX.listWidget.widthCorrection -1;
			}
//			alert( rows.length);
			for( var r=0; r < rows.length; r++){
				var widthCount = listWidth;
				var fields = this.getFields( rows[r]);
				for( var i=0; i < cols; i++){
					if( typeof( this.colWidth[i]) == "undefined"){
						if( i == cols -1){
							width = widthCount;
						}else{
							width = Math.round( widthCount /(cols -i));
						}
					}else{
						width = this.colWidth[i];
					}
					width += JSAX.listWidget.widthCorrection;
					fields[i].style.width = width+"px";
					widthCount -= fields[i].offsetWidth;
				}
			}
//			alert( width+" => "+widthCount);
			return true;
		},

		getRows: function(){
			return JSAX.listWidget.getRows( this);
		},

		getFields: function( row){
			if( row){
				return JSAX.listWidget.getFields( row);
			}else{
				return JSAX.listWidget.getFields( this);
			}
		}
	},

	isList: function( elem){
		if( elem.tagName == JSAX.listWidget.config.list.tagName){
			return true;
		}
		return false;
	},

	isRow: function( elem){
		if( elem.tagName == JSAX.listWidget.config.row.tagName){
			return true;
		}
		return false;
	},

	isField: function( elem){
		if( elem.tagName == JSAX.listWidget.config.field.tagName){
			return true;
		}
		return false;
	},
		
	getLists: function(){
		var lists = document.getElementsByClassName( "list");
		if( !lists.length){
			lists = document.getElementsByClassName( "LW_list");
		}
		return lists;
	},
	getRows: function( elem){
		return elem.getElementsByTagName( JSAX.listWidget.config.row.tagName);
	},
	getFields: function( elem){
		return elem.getElementsByTagName( JSAX.listWidget.config.field.tagName);
	},


	newLW: function(){
		var LW = document.createElement( JSAX.listWidget.config.list.tagName);
		LW.className = "LW_list";
		return LW;
	},
	addRowToList: function( row, LW){
		var RW = document.createElement( JSAX.listWidget.config.row.tagName);
		if( typeof( row) == "array"){
			for( var i =0; i < row.length; i++){
				JSAX.listWidget.addFieldToRow( fld, RW);
			}
		}else{
			JSAX.listWidget.RW.appendChild( row);
		}
		LW.appendChild( RW);
		return LW;
	},
	addFieldToRow: function( fld, RW){
		var FW = document.createElement( JSAX.listWidget.config.field.tagName);
		if( typeof( fld) ==  "string"){
			FW.innerHTML = fld;
		}
		RW.appendChild( FW);
		return RW;
	},


	activateAll: function(){
		var lists = JSAX.listWidget.getLists();
		for( var l=0; l < lists.length; l++){
			JSAX.listWidget.activate( lists[l]);
		}
	},
	createFromArray: function( array){
		var html_list		= JSAX.listWidget.newLW();
		var lines = array;
		for( var l=0; l < lines.length; l++){
			var html_row		= document.createElement( JSAX.listWidget.config.row.tagName);
			for( var f=0; f < lines[l].length; f++){
				var html_field		= document.createElement( JSAX.listWidget.config.field.tagName);
				html_field.innerHTML	= lines[l][f];
				html_row.appendChild( html_field);
			}
			html_list.appendChild( html_row);
		}
		JSAX.listWidget.activate( html_list);
		return html_list;
	},
	activate: function( list){
//		alert( typeof( list.getAttribute( "editable")));
		
		JSAX.object.attachTo( JSAX.listWidget.object, list);

		if( list.getAttribute( "editable")){
			list.editable = true;
			
		}
		var rows = list.getRows();
		for( var i=0; i < rows.length; i++){
			var row = rows[i];
			row.num = i;
			JSAX.listWidget.activateRow( row);
		}
		list.arrangeSize();

		// replace the list tag with the generated HTML
//		list.parentNode.insertBefore( html_list, list);
//		list.parentNode.removeChild( list);
//		alert( html_list.innerHTML);
		return true;
	},

	resizeAll: function(){
		if( !arguments[0] ){
			arguments[0] = 0;
		}
		var lists = JSAX.listWidtget.getLists();
		for( var l=0; l < lists.length; l++){
			lists[l].arrangeSize();
		}
		if( arguments[0] < 10 ){
			JSAX.listWidget.resizeAll( arguments[0] +1);
		}
	},


	activateRow: function( row){
//		row.innerHTML	= row.num+row.innerHTML;
		row.list	= row.parentNode;
		var fields = JSAX.listWidget.getFields( row);
		for( var i=0; i < fields.length; i++){
			var field = fields[i];
			field.num = row.num+"_"+i;
//			JSAX.listWidget.activateField( field);
		}
	}

/*
	createRow: function( row){
		var html_row		= document.createElement( "ol");
		html_row.num		= row.num;
		html_row.innerHTML	= row.num;
		var cols = row.getElementsByClassName( "field");
		for( var i=0; i < cols.length; i++){
			var col = cols[i];
			col.num = row.num+"_"+i;
			html_row.appendChild( JSAX.listWidget.createCol( col));
		}
		return html_row;
	},
	createCol: function( col){
		var html_col		= document.createElement( "li");
		html_col.className	= "LW_field";
		html_col.num		= col.num;
		html_col.innerHTML	= col.innerHTML;
		JSAX.listWidget.activateField( html_col);
		return html_col;
	},
*/

};

JSAX.listWidget.activateAll();

