

if( !window.JSAX){
	alert( "Element.js is not able to work without JavaScript Abstractions for X(HT)ML (objects/JSAX.js).");
}

/**
* Returns boolean true if the element has the class else false
* @param Object elem - The element wich should be checked
* @param String className - The className (for example: <TAG class="kd CLASSNAME">)
* @return boolead true if elem has className else false
*/
window.isClassMember = function( elem, className){
	if( typeof( elem.className) != "string"){
		return false;
	}
	if( elem.className == className
	 || elem.className.indexOf( className+" ") == 0
	 || elem.className.lastIndexOf( " "+className) == elem.className.length -className -1
	 || elem.className.indexOf( " "+className+" ") != -1){
		return true;
	}
	return false;
};

/**
* Element.js
* Element prototype extensions
*
* @parent JSAX.proto.Element
*
* Copyright (C) 2006 Florian Sax <flosax(at)users.sourceforge.net> 20060202
* Element.js is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
*
* @version 20060227
*
* @example: require( "proto/Element"); docement.body.insertBefore( document.createElement( "div"), docement.body.childNodes[0])
*/
JSAX.proto.Element = {
	"JSAX.proto.Element Version": 20060227,

/**
* Returns boolean true if the element has the class else false
* @param String className - The className (for example: <TAG class="kd CLASSNAME">)
* @return boolead true if elem has className else false
*/
isClassMember: function( className){
	return window.isClassMember( this, className);
},

/**
* Returns a list of all childNodes that have the given className
* @param String className - The className
* @return Array containing all elements that match the className
*/
getElementsByClassName: function( className){
	var elem = this;
	if( typeof( elem.getElementsByTagName) == "undefined"){
		elem = document;
	}
	if( typeof( elem.getElementsByTagName) == "function"){
		var allElems = elem.getElementsByTagName( "*");
	}else{
		var allElems = document.all;
	}
	var elems = new Array();
	for( var i=0; i < allElems.length; i++){
		if( isClassMember( allElems[i], className)){
			elems.push( allElems[i]);
		}
	}
	return elems;
},

/**
* Returns a list of all childNodes that have attribute with value
* @param String attrubute - The attrubute wich the elements must have.
* @param [Array value] - The value wich the attibute must be set to
* @return Array - All child Elements which matched the condistions of the given parameters
*/
getElementsBy: function( attribute, value){
	if( !value && !attribute){
		return false;
	}
	var elem = this;
	if( typeof( elem.getElementsByTagName) == "undefined"){
		elem = document;
	}
	if( typeof( elem.getElementsByTagName) == "function"){
		var allElems = elem.getElementsByTagName( "*");
	}else{
		var allElems = document.all;
	}
	var elems = new Array();
	for( var i=0; i < allElems.length; i++){
		if( typeof( value) == "undefined"){
			if( typeof( allElems[i][attribute]) != "undefined"){
				elems.push( allElems[i]);
			}
		}else if( allElems[i][attribute] == value){
			elems.push( allElems[i]);
		}
	}
	return elems;
},

/**
* Returns the value if the element has it. if not the innerHTML
* @return String - The content of the Element
*/
returnValue: function(){
	if( typeof( this.value) == "undefined"){
		return this.value;
	}else{
		return this.innerHTML;
	}
},

/**
* Removes the element (it can not be reviewed)
*/
removeNode: function(){
	this.parentNode.removeChild( this);
}



};

// assign getElementsByClassName to document as well
document.getElementsByClassName = JSAX.proto.Element.getElementsByClassName;




// the horrible procedure to pretend beein able to assign it to the Element.prototype in all Browsers
JSAX.proto.ElementPrototype = {
assign: function(){

	// get the a Element with prototype at JSAX.proto.Element.protoElem
	JSAX.proto.ElementPrototype.object = document.createElement( "DIV");
	
	// Mozilla & Opera(w3c)
	if( window.HTMLElement){
	//	alert( "HTMLElement");
		JSAX.proto.ElementPrototype.object = HTMLElement.prototype;
	
	// KHTML
	}else if( window["[[DOMElement.prototype]]"]){
	//	alert( "[[DOMElement.prototype]]");
		JSAX.proto.ElementPrototype.object = window["[[DOMElement.prototype]]"];
	
	// ?? Probably exists as well who knows, i do not know what safari or icab use
	}else if( window.DOMElement){
	//	alert( "DOMElement");
		JSAX.proto.ElementPrototype.object = DOMElement.prototype;
	
	// M$IE does not support element prototyping
	}else{
		JSAX.proto.ElementPrototype.object = false;
	}
	
	
	if( JSAX.proto.ElementPrototype){ // M O K
		JSAX.object.attachTo( JSAX.proto.Element, JSAX.proto.ElementPrototype.object);
	
	// M$IE
	// micro$oft does not support element prototyping at all, not even over objects. that's a shame.
	// so we assign it to all elements one by one and repeat this procedure recursivly after 0.1 sec
	}else{
		JSAX.proto.ElementPrototype.runtime = setInterval( "JSAX.proto.ElementPrototype.assignIE();", 100);
	}
},
assignIE: function(){
	return JSAX.proto.ElementPrototype.assignToAllElements( 'JSAX.proto.Element');
},
assignToAllElements: function( objP){
	var obj = eval( objP);
	var elems = document.getElementsByTagName( "*");
	for( var i=0; i < elems.length; i++){
		JSAX.object.attachTo( obj, elems[i]);
	}
}
};

JSAX.proto.ElementPrototype.assign();

