if( !window.JSAX){
	alert( "JSAX.proto.String needs JavaScript Abstractions for X(HT)ML (objects/JSAX.js) to work.");
}
/**
* String prototype library - string.js
* this is a collection of usefull javascript functions
* written by Florian Sax 20051217
*
* Copyright (C) 2006 Florian Sax <flosax(at)users.sourceforge.net>
* String.js is protected by the GPL <http://www.gnu.org/copyleft/gpl.html>
* @version 20060215
*/
JSAX.proto.String = {

	"JSAX.proto.String Version": 20060215,

/**
* Removes whitespaces from the end and the beginning of this
*
* @return String
*/
trim: function(){
	var string = this.toString();
/*	while( string[0] == "\n" || string[0] == "\t" || string[0] == " "){
		string = string.substr( 1);
	}
	while( string[-1] == "\n" || string[-1] == "\t" || string[-1] == " "){
		string = string.substr( 0, -1);
	}*/
	while( string.length > 0 &&
		( string.charCodeAt( 0) == 9
		|| string.charCodeAt( 0) == 10
		|| string.charCodeAt( 0) == 13
		|| string.charCodeAt( 0) == 32)){
			string = string.substring( 1);
	}
	while( string.length > 0 &&
		( string.charCodeAt( string.length -1) == 9
		|| string.charCodeAt( string.length -1) == 10
		|| string.charCodeAt( string.length -1) == 13
		|| string.charCodeAt( string.length -1) == 32)){
			string = string.substring( 0, string.length -1);
	}
	return string;
},

/**
* Splits the string and removes the whitespaces from the end and beginning of evrey item
*
* @param String sep - The separator used in the string
*
* @return Array
*
* @example " test, item , whaterer,3, 5, tsst".trimSplit( ",")
*/
trimSplit: function( sep){
	var string = this.toString();
	var array = string.trim().chopEnd( sep).split( sep);
	for( var i=0; i < array.length; i++){
		array[i] = array[i].trim();
	}
	return array;
},

/**
* Splits the string caseindsensitiv and removes the whitespaces from the end and beginning of evrey item
*
* @param String sep - The separator used in the string
*
* @return Array
*/
trimSpliti: function( sep){
	var string = this.toString();
	var array = string.trim().chopEnd( sep).spliti( sep);
	for( var i=0; i < array.length; i++){
		array[i] = array[i].trim();
	}
	return array;
},

/**
* Splits the string caseindsensitiv
*
* @param String sep - The separator used in the string
*
* @return Array
*/
spliti: function( sep){
	var string = this.toString();
	var array = new Array();
	var pos = string.posi( sep);
	while( pos != -1){
		array.push( string.substr( 0, pos));
		string = string.substr( pos +sep.length);
		pos = string.posi( sep);
	}
	return array;
},


/**
* Split this string with multiple possible separators
*
* @param Array [args] - The separators used in the string (default= [",", ".", ";", ":", "\n", "\t", " ", "-", "_"])
*
* @return Array
*
* @example "this,is.a_st-ring!".smartSplit( [",",".","_","-","!"])
*/
smartSplit: function( args, keepEmpty, trim){
	var seps = [];
	if( typeof( args) == "object"){
		seps = args;
	}else if( typeof( args) == "string" && args.length){
		seps.push( args);
	}
	if( !seps.length){
		seps = [",", ".", ";", ":", "\n", "\t", " ", "-", "_"];
	}
	var string = this.toString();
	var array = [];
	var sep = seps[1];
	var part = "";
	var pos, cpos = 0;
	while( string.length){
		pos = -1;
		for( var i = 0; i < seps.length; i++){
			cpos = string.pos( seps[i]);
			if( cpos > -1 && ( cpos < pos || pos == -1)){
				sep = seps[i];
				pos = cpos;
			}
		}
		if( pos == -1){
			part = string;
			string = "";
		}else{
			part = string.substr( 0, pos);
			string = string.substr( pos +sep.length);
		}
		if( trim){
			part = part.trim();
		}
		if( keepEmpty || part.length){
			array.push( part);
		}
	}
	return array;
},


/**
* JSAX.proto.String.pos - returns the first position of find
*
* @param Mixed find - Can be a string or a array of strings
* @param Boolean addLength - The length of the matched string will be added to the return if this parameter is set
*
* @return Number - The first match or -1
*
* @example "testString".pos( "S")
* @example "testString".pos( ["r", "S", "q"])
*/
pos: function( find, addLength){
	if( typeof( find) == "string" || typeof( find) == "number"){
		var find = [find];
	}
	if( typeof( find) != "object" || !find.length){
		return -1;
	}
	var pos = -1;
	var p = -1;
	var c = "";
	var s = this.toString();
	for( var i = 0; i < find.length; i++){
		p = s.indexOf( find[i]);
		if( ( p != -1 && ( pos == -1 || p < pos))
		 || ( addLength && p == pos && c.length < find[i].length)){
			pos = p;
			c = find[i];
		}
	}
	if( addLength && pos > -1){
		pos += c.length;
	}
	return pos;
},

/**
* JSAX.proto.String.posi - Returns the first position of find without case sensitivity
*
* @param Mixed find - Can be a string or a array of strings
* @param Boolean addLength - The length of the matched string will be added to the return if this parameter is set
*
* @return Number - The first match or -1
*
* @example "testString".posi( "S")
*
* NOTE miltiple find does not work. needs fix
*/
posi: function( find, addLength){
	return this.toString().toLowerCase().pos( find.toLowerCase(), addLength);
},

/**
* JSAX.proto.String.posi - Returns the last position of find in this
*
* @param Mixed find - Can be a string or an array of strings
* @param Boolean addLength - The length of the matched string will be added to the return if this parameter is set
*
* @return Number - The first from the right match or -1
*
* @example "testString".lpos( "S")
* @example "testString".lpos( ["r", "S", "q"])
*/
lpos: function( find, addLength){
	if( typeof( find) == "string" || typeof( find) == "number"){
		var find = [find];
	}
	if( typeof( find) != "object" || !find.length){
		return -1;
	}
	var pos = -1;
	var p = -1;
	var c = "";
	var s = this.toString();
	for( var i = 0; i < find.length; i++){
		p = s.lastIndexOf( find[i]);
		if( p > pos
		 || ( addLength && p == pos && c.length < find[i].length)){
			pos = p;
			c = find[i];
		}
	}
	if( addLength && pos > -1){
		pos += c.length;
	}
	return pos;
},
/**
* NOTE miltiple find does not work. needs fix
*/
lposi: function( find, addLength){
	return this.toString().toLowerCase().lpos( find.toLowerCase(), addLength);
},

posr: function( find, addLength){
	return this.toString().lpos( find, addLength);
},
/**
* NOTE miltiple find does not work. needs fix
*/
posri: function( find, addLength){
	return this.toString().lposi( find, addLength);
},
/**
* NOTE must be rewritten
*/
rpos: function( find, addLength){
	var lastPos = this.toString().lpos( find, addLength);
	if( lastPos == -1){
		return -1;
	}
	return this.toString().length -( lastPos +find.length);
},
/**
* NOTE miltiple find does not work. needs fix
*/
rposi: function( find, addLength){
	return this.toString().toLowerCase().posr( find.toLowerCase(), addLength);
},

/**
* Returns the number the string occuring in this
* @return Number - The numer of times find is in this
*/
indexCount: function( find){
	return this.toString().split( find).length -1
},
indexCounti: function( find){
	return this.toString().toLowerCase().split( find.toLowerCase()).length -1
},

/**
* Returns the position of the first occuring hidden character (space, tab, linebrake) or -1
* @return Number - The position of the first white space
*/
whitePos: function(){
	var c = [" ", "\t", "\n"];
	return this.toString().pos( c);
},
/**
* This is a deprechiated alias to WhitePos() and it will be removed. please use whitePos().
*/
whiteCharPos: function(){
	return this.toString().whitePos();
},

/**
* returns true if this has at least one uppercase character
* @return Boolean
*/
hasUpperCase: function(){
	return ( ( this.toString().toLowerCase() != this.toString()) ? true : false )
},
/**
* returns true if this has at least one uppercase character
* @return Boolean
*/
hasLowerCase: function(){
	return ( ( this.toString().toUpperCase() != this.toString()) ? true : false )
},


/**
* Chop the biginning by string, or string list
*
* @param Mixed charsOrArray - A string or a list of string you want to have removed from the beginning
*
* @return String
*
* @example "testString".chopBegin( "te")
* @example "testString".chopBegin( ["ing", "r", "t", "tes"])
*/
chopBegin: function( charsOrArray){
	var a = [];
	if( typeof( charsOrArray) == "object"){
		a = charsOrArray;
	}else if( arguments.length > 1){
		for( var i = 0; i < arguments.length; i++){
			a.push( arguments[i]);
		}
	}else{
		a = charsOrArray;
	}

	s = this.toString();
	while( s.pos( a) == 0){
		s = s.substr( s.pos( a, 1));
	}
	return s;
},

/**
* Chop the end by string, length or string list
*
* @param Mixed charsOrArray - A position number, a string or a list of string you want to have removed from the end
*
* @return String
*
* @example "testString".chopEnd( "te")
* @example "testString".chopEnd( ["ing", "r", "t", "tes"])
*/
chopEnd: function( charsOrArray){
	var a = [];
	if( typeof( charsOrArray) == "object"){
		a = charsOrArray;
	}else if( arguments.length > 1){
		for( var i = 0; i < arguments.length; i++){
			a.push( arguments[i]);
		}
	}else{
		a = charsOrArray;
	}

	s = this.toString();
	while( s.lpos( a, 1) == s.length){
		s = s.substr( 0, s.lpos( a));
	}
	return s;
},

/**
* Returns true if this could be a number
*
* @return Boolean - True or false
*/
canBeANumber: function(){
	if( parseInt( this).toString() != parseInt( "this is a string").toString()){
		return true;
	}else{
		return false;
	}
},

/**
* replace all string with another
*/
str_replace: function( search, replace){
	var string = this.toString();
	if( search === null){
		return string;
	}
	if( !string.length){
		return "";
	}
	var search = search.toString();
	if( !search.length){
		return string;
	}
	var newString = "";
	while( string.length){
		var pos = string.pos( search);
		if( pos == -1){
			newString += string;
			string = "";
		}else{
			newString += string.substring( 0, pos);
			newString += replace;
			string = string.substring( pos+search.length);
		}
	}
	return newString;
},

/**
* replace all string with another without casesensitivity
*/
stri_replace: function( search, replace){
	var string = this.toString();
	if( search === null){
		return string;
	}
	if( !string.length){
		return "";
	}
	var search = search.toString();
	if( !search.length){
		return string;
	}
	var newString = "";
	while( string.length){
		var pos = string.posi( search);
		if( pos == -1){
			newString += string;
			string = "";
		}else{
			newString += string.substring( 0, pos);
			newString += replace;
			string = string.substring( pos+search.length);
		}
	}
	return newString;
},

/**
* Replaces all newline chars "\n" with <br/>\n
*
* @return String
*/
nl2br: function(){
	var string = this.toString();
	string = string.str_replace( "\n", "<br/>\n");
	return string;
},

/**
* Escapes Tags, specialchars and hiddenchars for viewing HTML
*
* @return String
*/
txt2html: function(){
	var string = this.toString();
	string = string.str_replace( "&", "&amp;");
	string = string.str_replace( "<", "&lt;");
	string = string.str_replace( ">", "&gt;");
	string = string.str_replace( "\t", "    ");
	string = string.str_replace( "  ", "&nbsp; ");
	string = string.nl2br();
	return string;
},


/**
* Removes all script comments from the string
*
* @return String
*/
removeScriptComments: function(){
	var string = this.toString();
	string = string.replace( /\/\/.*/g, "");

//	alert( string.search( /\/\/?[^\n]\n/gi));
//	alert( string.search( /\/\/.*/));
//	alert( string.search( /\/?[^\12]\12/gi));
//	string = string.replace( /\/\/ */gi, "");
//	alert(string.search( /(\/\*)[^(\*\/)]+(\*\/)/));
//	string = string.replace( /(\/\*)[^(\*\/)]+(\*\/)/, "");
	var start = string.indexOf( "/*");
	var end = string.indexOf( "*/");
	while( start != -1 && end != -1){
		string = string.substring( 0, start)+string.substring( end+2);
		start = string.indexOf( "/*");
		end = string.indexOf( "*/");
	}
	if( start != -1 && end == -1){
		string = string.substring( 0, start);
	}
	return string;
},


/**
* Removes all tags from the string
*
* @return String
*/
stripTags: function(){
	return this.toString().replace(/<\/?[^>]+>/gi, "");
},

/**
* Escapes HTML specialchars as the browser does it himself
*/
escapeHTML: function(){
	var div = document.createElement( 'div');
	var text = document.createTextNode( this.toString());
	div.appendChild( text);
	return div.innerHTML;
},

/**
* unescaped escaped HTML
*/
unescapeHTML: function(){
	var max = 4096;
	var num = this.toString().length /max;
	var string = "";
	for( var i = 0; i < num; i++){
		var div = document.createElement('div');
		div.innerHTML = this.substr( i*max, (i+1)*max-1).stripTags();
		string += div.childNodes[0].nodeValue;
	}
	return string;
}
};

JSAX.object.attachTo( JSAX.proto.String, String.prototype);

